{$O-,Q+,R+}

const eps=1e-12;

function gcd (a, b : integer) : integer;
begin
  if b = 0 then gcd := a else gcd := gcd (b, a mod b);
end;

var x, y, z : array [1..100] of integer;
    z01, z02, zv, x1, y1, z1, x2, y2, z2, a, b, c, d, i, j, k, vc, wc : integer;
    pa, pb, pc, pd : array [1..1000] of integer;
    g, n, st, l, cur, plc : integer;
    ig : boolean;
    xv, yv, xw, yw : array [1..500] of extended;

procedure putw (x, y : extended);
begin
  inc (wc);
  xw[wc] := x; yw[wc] := y;
  //writeln (erroutput, '  ', x:5:5, ',', y:5:5);
end;

procedure intersectpoly(a, b, c : integer);
var i: integer;
    s, t1, t2 : extended;
begin
  if vc = 0 then exit;
  //writeln (erroutput, 'intersect with ',a,'*X+',b,'*Y+',c,'>=0');
  xv[vc+1]:=xv[1];  yv[vc+1]:=yv[1];
  wc := 0;
  for i := 1 to vc do begin
    t1 := a*xv[i]+b*yv[i]+c;
    t2 := a*xv[i+1]+b*yv[i+1]+c;
    if t1 >= -eps then putw(xv[i],yv[i]);
    if (t1*t2 < -eps) then begin
      s:=t2-t1;
      putw((t2*xv[i]-t1*xv[i+1])/s, (t2*yv[i]-t1*yv[i+1])/s);
    end
  end;
  if wc < 3 then wc := 0;
  vc := wc;
  for i := 1 to vc do begin
    xv[i]:=xw[i];  yv[i]:=yw[i];
  end;
end;

function area : extended;
var i : integer;
    sum : extended;
begin
  xv[vc + 1] := xv[1];
  yv[vc + 1] := yv[1];

  sum := 0;

  for i := 1 to vc do 
    sum := sum + xv[i] * yv[i + 1] - xv[i + 1] * yv[i];

  area := sum * 0.5;
end;


begin
  reset (input, 'aerodynamics.in');
  rewrite (output, 'aerodynamics.out');
  read (n, z01, z02);
  for i := 1 to n do read (x[i], y[i], z[i]);

  plc := 0;

  for i := 1 to n do
    for j := i + 1 to n do
      for k := j + 1 to n do begin
        x1 := x[j] - x[i];
        y1 := y[j] - y[i];
        z1 := z[j] - z[i];
        x2 := x[k] - x[i];
        y2 := y[k] - y[i];
        z2 := z[k] - z[i];
        a := y1 * z2 - z1 * y2;
        b := z1 * x2 - x1 * z2;
        c := x1 * y2 - y1 * x2;
        d := a * x[i] + b * y[i] + c * z[i];

        if (a = 0) and (b = 0) and (c = 0) then continue;

        st := 0;
        for l := 1 to n do begin
          cur := a * x[l] + b * y[l] + c * z[l] - d;
          if cur < 0 then begin
            case st of
              0: st := 1;
              1: st := 2;
            end;
            if st = 2 then break;
            a := -a; b := -b; c := -c; d := -d;
          end else
          if cur > 0 then case st of
            0: st := 1;
          end;
        end;

        if st < 2 then begin
          g := gcd (a, b);
          g := gcd (g, c);
          g := gcd (g, d);
          g := abs (g);
          a := a div g; b := b div g; c := c div g; d := d div g;

          for l := 1 to plc do
            if (a = pa[l]) and (b = pb[l]) and (c = pc[l]) and (d = pd[l]) then begin
              st := 2;
              break;
            end;

          if st < 2 then begin
            inc (plc);
            pa[plc] := a;
            pb[plc] := b;
            pc[plc] := c;
            pd[plc] := d;
          end;
        end;
      end;


  {for i := 1 to plc do
    writeln (erroutput, pa[i], ' ', pb[i], ' ', pc[i], ' ', pd[i]);
  }

  for zv := z01 to z02 do begin
    ig := false;
    for i := 1 to plc do begin
      if (pa[i] = 0) and (pb[i] = 0) then begin
        if pc[i] * zv - pd[i] < 0 then begin
          ig := true;
          break;
        end;
      end;
    end;

    if ig then begin
      writeln ('0');
      continue;
    end;

    vc := 4;
    xv[1] := -100; yv[1] := -100;
    xv[2] :=  100; yv[2] := -100;
    xv[3] :=  100; yv[3] :=  100;
    xv[4] := -100; yv[4] :=  100;

    for i := 1 to plc do if (pa[i] <> 0) or (pb[i] <> 0) then begin
      intersectpoly(pa[i],pb[i],pc[i]*zv-pd[i]);
    end;
    writeln (area : 0 : 20);
  end;

end.