#include <stdio.h>
#include <math.h>
const double PI = 3.14159265358979323;
const double EPS = 1.E-9;
struct tpoint
{
	double x,y;
	tpoint(double xx=0, double yy=0)
	{
		x=xx;
		y=yy;
	}

	tpoint operator + (tpoint b) 
	{
		return tpoint(x+b.x,y+b.y);
	}

	tpoint operator - (tpoint b) 
	{
		return tpoint(x-b.x,y-b.y);
	}

	tpoint operator / (double a) 
	{
		return tpoint(x/a,y/a);
	}

	double len2()
	{
		return x*x+y*y;
	}

	tpoint rotate(double a)
	{
		return tpoint(x*cos(a)-y*sin(a), x*sin(a)+y*cos(a));
	}
};

double area(tpoint a, tpoint b, tpoint c)
{
	a = a-c;
	b = b-c;
	return a.x*b.y-a.y*b.x;
}

double min(double a, double b)
{
	return a<b?a:b;
}

double max(double a, double b)
{
	return a<b?b:a;
}

int intersect(tpoint a, tpoint b, tpoint c, tpoint d)
{
	if (max(a.x,b.x)<min(c.x,d.x)+EPS ||
	    max(a.y,b.y)<min(c.y,d.y)+EPS ||
	    max(c.x,d.x)<min(a.x,b.x)+EPS ||
	    max(c.y,d.y)<min(a.y,b.y)+EPS)
		return 0;

	if (area(a,b,c)*area(a,b,d) > -EPS ||
	    area(c,d,a)*area(c,d,b) > -EPS)
		return 0;
	return 1;
}

tpoint turns[1000];
int main()
{
	tpoint p;
	tpoint zero(0,0);
	scanf("%lf%lf",&p.x,&p.y);
	turns[0] = tpoint(10,0);
	turns[1] = tpoint(5,5);
	double ans = 0.0;
	for (int i=1;i<500;i++)
	{
		double s = area(turns[i-1],turns[i],p);
		if (intersect(zero,p,turns[i-1],turns[i]) || fabs(s)<EPS)
			ans += (turns[i]-turns[i-1]).len2();
		if (s<=-EPS)
			turns[i+1] = turns[i] + (turns[i-1]-turns[i]).rotate(PI/4)/sqrt(2.0);
		else
		if (s>=EPS)
			turns[i+1] = turns[i] + (turns[i-1]-turns[i]).rotate(-PI/4)/sqrt(2.0);
		else {
			break;
		}
	}

	printf("%.10lf",ans/2.0);
	return 0;
}
