#pragma comment(linker, "/STACK:64000000")
#define _CRT_SECURE_NO_WARNINGS

#include <cstdio>
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <sstream>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define for1(i, n) for (int i = 1; i <= int(n); i++)
#define forv(i, v) forn(i, v.size())

#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair

#define CIN_FILE "input.txt"
#define COUT_FILE "output.txt"

#define pi 3.1415926535897932

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

#define NMAX 1000005
#define EPS 1e-12

struct Line
{
    int a, b, c;
};

int det(int x1, int y1, int x2, int y2)
{
    return x1 * y2 - x2 * y1;
}

ld ddet(ld x1, ld y1, ld x2, ld y2)
{
    return x1 * y2 - x2 * y1;
}

bool upper(int x, int y)
{
    return x > 0 || (x == 0 && y > 0);
}

inline bool Cmp(const Line& l1, const Line& l2)
{
    if (upper(l1.a, l1.b) != upper(l2.a, l2.b)) return upper(l1.a, l1.b) > upper(l2.a, l2.b);
    if (det(l1.a, l1.b, l2.a, l2.b) != 0) return det(l1.a, l1.b, l2.a, l2.b) > 0;
    return l1.c / sqrtl(l1.a * l1.a + l1.b * l1.b) < l2.c / sqrtl(l2.a * l2.a + l2.b * l2.b);
}

int n;
Line l[NMAX];

int two_parallel(Line l1, Line l2)
{
    if (-l2.c < l1.c) return -1;
    return 0; 
}

struct Point
{
    double x, y;
};

Point cross(Line& l1, Line& l2)
{
    Point p;
    p.x = 1.0 * det(l1.c, l1.b, l2.c, l2.b) / det(l1.a, l1.b, l2.a, l2.b);
    p.y = 1.0 * det(l1.a, l1.c, l2.a, l2.c) / det(l1.a, l1.b, l2.a, l2.b);
    return p;
}
Point st[NMAX];
int top;
int stl[NMAX];
bool used[NMAX];

int main()
{
  //  freopen(CIN_FILE, "rt", stdin);
  //  freopen(COUT_FILE, "wt", stdout);

    scanf("%d", &n);
    forn(i, n)
    {
        scanf("%d %d %d", &l[i].a, &l[i].b, &l[i].c);    
    }

    sort(l, l + n, Cmp);

    int k = 0;
    forn(i, n)
    {
        if (i == 0 || (i > 0 && (det(l[i].a, l[i].b, l[i - 1].a, l[i - 1].b) != 0 || upper(l[i].a, l[i].b) != upper(l[i - 1].a, l[i - 1].b))))
        {
            l[k++] = l[i];
        } 
    }
    n = k;

    if (n == 1)
    {
        cout << -1 << endl;
        return 0;
    }

    forn(i, n)
    {
        l[i + n] = l[i];
    }

    forn(i, n)
    {
        if (det(l[i].a, l[i].b, l[i + 1].a, l[i + 1].b) == 0)
        {
            cout << two_parallel(l[i], l[i + 1]) << endl;
            return 0;
        }

        if (det(l[i].a, l[i].b, l[i + 1].a, l[i + 1].b) < 0)
        {
            cout << -1 << endl;
            return 0;
        }
    }

    top = 1;    
    st[0] = cross(l[0], l[1]);
    used[0] = used[1] = true;
    stl[0] = 0;
    stl[1] = 1;

    for (int i = 2; i < 2 * n; i++)
    {
        while (top > 0)
        {
            Point p = cross(l[i], l[stl[top]]);            
            if (ddet(p.x - st[top - 1].x, p.y - st[top - 1].y, l[stl[top]].a, l[stl[top]].b) < -EPS) break;
            used[stl[top]] = false;
            top--;
        }
        st[top++] = cross(l[i], l[stl[top]]);    
        stl[top] = i;

        used[i] = true;
    }

    int front = top;
    forn(j, top)
    {
        if (stl[j] >= n && used[stl[j] - n])
        {
            top = j + 1;
            forn(i, top)
            {
                if (stl[i] + n == stl[j])
                {
                    front = i + 1;
                    break;
                }
            }
        }
    }
    st[top] = st[front];

    ld sq = 0;
    for (int i = front; i < top; i++)
    {
        sq += (st[i].x - st[i + 1].x) * (st[i].y + st[i + 1].y);
    }
    sq *= 0.5;

    cout.precision(10);
    cout << fixed;

    cout << sq << endl;
    return 0;
}