#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>
#include <ctime>
#include <cassert>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back
#define y0 askjdfghjksdf
#define y1 askldjfahsd
#define fst first
#define snd second

template<typename T> T abs(T x) {if (x>=0) return x; return -x;}

const ld eps = 1e-9;

bool cw(const pair < ld, ld > &a, const pair < ld, ld > &b, const pair < ld, ld > &c)
{
	return a.fst * (b.snd - c.snd) + b.fst * (c.snd - a.snd) + c.fst * (a.snd - b.snd) > eps;
}

bool ccw(const pair < ld, ld > &a, const pair < ld, ld > &b, const pair < ld, ld > &c)
{
	return a.fst * (b.snd - c.snd) + b.fst * (c.snd - a.snd) + c.fst * (a.snd - b.snd) < -eps;
}

void hull(vector < pair < ld, ld > > &a)
{
	if (a.size() <= 1)
	{
		return;
	}

	vector < pair < ld, ld > > up, down;
	up.pb(a[0]);
	down.pb(a[0]);

	int n = a.size();

	for (int i = 1; i < n; i++)
	{
		if (i == n - 1 || cw(a[0], a[i], a[n - 1]))
		{
			while (down.size() > 1 && !cw(down[down.size() - 2], down.back(), a[i]))
				down.pop_back();
			down.pb(a[i]);
		}

		if (i == n - 1 || ccw(a[0], a[i], a[n - 1]))
		{
			while (up.size() > 1 && !ccw(up[up.size() - 2], up.back(), a[i]))
				up.pop_back();
			up.pb(a[i]);
		}
	}

	a.clear();
	for (int i = 0; i < up.size(); i++)
		a.pb(up[i]);

	for (int i = (int)down.size() - 2; i > 0; i--)
		a.pb(down[i]);
}

const int maxn = 105;


ld x[maxn], y[maxn], z[maxn];

ld sqr(ld x)
{
	return x * x;
}

int main()
{
	//freopen("a.in", "r", stdin);

	int n, zmin, zmax;
	cin >> n >> zmin >> zmax;

	for (int i = 0; i < n; i++)
		cin >> x[i] >> y[i] >> z[i];

	for (int zp = zmin; zp <= zmax; zp++)
	{
		vector < pair < ld, ld > > a;

		for (int i = 0; i < n; i++)
		{
			if (abs((ld)zp - z[i]) < eps)
				a.pb(mp(x[i], y[i]));

			for (int j = i + 1; j < n; j++)
			{
				if (z[i] < zp && z[j] < zp)
					continue;

				if (z[i] > zp && z[j] > zp)
					continue;

				if (abs(z[i] - z[j]) < eps)
					continue;

				ld t = 1.0 - (z[i] - zp) / (z[i] - z[j]);

				ld xx = x[i] * t + x[j] * (1.0 - t);
				ld yy = y[i] * t + y[j] * (1.0 - t);

				a.pb(mp(xx, yy));
			}
		}

		sort(a.begin(), a.end());
		a.resize(unique(a.begin(), a.end()) - a.begin());
		hull(a);
		

		ld area = 0;

		if (a.size() > 2)
		{
			for (int i = 0; i < a.size(); i++)
			{
				int i2 = (i + 1) % a.size();

				area += (a[i].snd + a[i2].snd) * (a[i].fst - a[i2].fst);
			}

			area = abs(area / 2.0);
		}

		cout.precision(10);
		cout << fixed << area << endl;
	}


	return 0;
}