#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>
#include <ctime>
#include <cassert>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back
#define y0 askjdfghjksdf
#define y1 askldjfahsd
#define fst first
#define snd second

template<typename T> T abs(T x) {if (x>=0) return x; return -x;}

const ld eps = 1e-9;

inline ld sqr(ld x)
{
	return x * x;
}

struct point
{
	ld x, y, z;

	point()
	{
		x = y = z = 0;
	}

	point(ld _x, ld _y, ld _z)
	{
		x = _x, y = _y, z = _z;
	}

	point operator *(const point &other)
	{
		return point(y * other.z - z * other.y, -(x * other.z - z * other.x), x * other.y - y * other.x);
	}

	ld operator % (const point &other)
	{
		return x * other.x + y * other.y + z * other.z;
	}

	ld len()
	{
		return sqrt(sqr(x) + sqr(y) + sqr(z));
	}

	point operator -(const point &b)
	{
		return point(x - b.x, y - b.y, z - b.z);
	}

	point operator + (const point &b)
	{
		return point(x + b.x, y + b.y, z + b.z);
	}

	point operator / (const ld d)
	{
		return point(x / d, y / d, z / d);
	}

	point operator * (const ld d)
	{
		return point(x * d, y * d, z * d);
	}

	point normalize()
	{
		ld l = len();
		return point(x / l, y / l, z / l);
	}
};

int intersect(point &A, point &B, point &C, point &D)
{
	if (abs((B - A) * (C - A) % (D - A)) > eps)
	{
		return 0;
	}

	if (abs(((A - B) * (C - D)).len()) < eps)
	{
		if (abs(((C - A) * (D - A)).len()) < eps) return 2;
		return 0;
	}

	point normal = ((A - B) * (C - B)).normalize();
	point v = B - A;
	ld s1 = (C - A) * (D - A) % normal;
	ld s2 = (D - B) * (C - B) % normal;
	ld s = s1 + s2;
	v = v / s;
	v = v * s1;
	point O = A + v;

	return ((A - O) % (B - O) < -eps) && ((C - O) % (D - O) < -eps);
}

ld solve()
{
	int n;
	cin >> n;

	ld sx = 0.0, sy = 0.0, sz = 0.0;

	vector < point > a;
	for (int i = 0; i < n; i++)
	{
		ld x, y, z;
		cin >> x >> y >> z;
		sx += x;
		sy += y;
		sz += z;
		a.pb(point(x, y, z));
	}

	sx /= n, sy /= n, sz /= n;

	point s(sx, sy, sz);

	vector < vector < int > > faces;
	ld sVolume = 0.0;
	
	point center(0, 0, 0);
	map < pair < int, int >, int > cnt;

	vector < pair < int, int > > was;

	for (int i = 0; i < n; i++)
	{
		for (int j = i + 1; j < n; j++)
		{
			for (int k = j + 1; k < n; k++)
			{
				point v = ((a[j] - a[i]) * (a[k] - a[i]));

				if (v.len() < eps)
					continue;

				bool any = false;

				for (int iter = 0; iter < 2; iter++)
				{
					bool good = true;

					for (int h = 0; h < n; h++)
					{
						if (iter)
							good &= (v % (a[h] - a[i])) > -eps;
						else
							good &= (v % (a[h] - a[i])) < eps;
					}

					if (good)
						any = true;
				}

				if (!any)
					continue;

				if (cnt[mp(min(i, j), max(i, j))] == 2)
					continue;
				

				if (cnt[mp(min(i, k), max(i, k))] == 2)
					continue;
				

				if (cnt[mp(min(j, k), max(j, k))] == 2)
					continue;


				
				auto ch = [was, &a](int u, int v)
				{

					bool good = true;

					for (auto x : was)
					{
						if (x == mp(min(u, v), max(u, v)))
							continue;

						if (x.fst == u || x.fst == v || x.snd == u || x.snd == v)
							continue;

						good &= intersect(a[x.fst], a[x.snd], a[u], a[v]) != 1;
					}

					return good;
				};

				if (!ch(i, j) || !ch(j, k) || !ch(k, i))
					continue;


				cnt[mp(min(i, k), max(i, k))]++;
				cnt[mp(min(i, j), max(i, j))]++;
				cnt[mp(min(j, k), max(j, k))]++;

				was.pb(mp(min(i, j), max(i, j)));
				was.pb(mp(min(i, k), max(i, k)));
				was.pb(mp(min(k, j), max(k, j)));

				ld volume = abs(v % (s - a[i])) / 6.0;
				sVolume += volume;

				point c = (a[i] + a[j] + a[k] + s) / 4.0;

				center = center + c * volume;
				
				vector < int > f;
				f.pb(i); f.pb(j); f.pb(k);

				faces.pb(f);
			}
		}
	}

	center = center / sVolume;


	ld ans = 1e18;


	for (auto x : faces)
	{
		point v = ((a[x[1]] - a[x[0]]) * (a[x[2]] - a[x[0]])) ;
		//ld  curr = abs((v % (center - a[x[0]])) / v.len());
		ans = min(ans, abs((v % (center - a[x[0]])) / v.len()));
	}

	return ans;
}


int main()
{
	//freopen("a.in", "r", stdin);
	cout.precision(10);
	cout << fixed << (solve() + solve()) << endl;

	return 0;
}