#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>
#include <fstream>
#include <time.h>
#include <cassert>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back
#define y0 askjdfghjksdf
#define y1 askldjfahsd
#define fst first
#define snd second
#define uint unsigned int

template<typename T> T abs(T x) {if (x>=0) return x; return -x;}

double sqr(double a)
{
	return a * a;
}

bool doubleEqual(double a, double b)
{
	return fabs(a - b) < 1e-9;
}

bool doubleLessOrEqual(double a, double b)
{
	return a < b || doubleEqual(a, b);
}

bool doubleLess(double a, double b)
{
	return a < b && !doubleEqual(a, b);
}

bool doubleGreaterOrEqual(double a, double b)
{
	return a > b || doubleEqual(a, b);
}

bool doubleGreate(double a, double b)
{
	return a > b && !doubleEqual(a, b);
}

double mySqrt(double a)
{
	if (doubleLess(a, 0))
	{
		throw "sqrt(-1)";
	}
	if (a < 0)
		return 0;
	return sqrt(a);
}


struct Point
{

public:
	double x, y;


	Point() : x(0), y(0) {}

	Point(double x, double y) : x(x), y(y) {}

	void scan()
	{
		scanf("%lf %lf", &x, &y);
	}

	void print() const
	{
		printf("%.10lf %10lf\n", x, y);
	}

	Point operator+(const Point & p) const
	{
		return Point(x + p.x, y + p.y);
	}

	Point operator-(const Point & p) const
	{
		return Point(x - p.x, y - p.y);
	}

	Point operator-() const 
	{
		return Point(-x, -y);
	}

	Point operator*(double k) const
	{
		return Point(x * k, y * k);
	}

	Point operator/(double k) const
	{
		return Point(x / k, y / k);
	}

	double operator%(const Point & p) const
	{
		return x * p.x + y * p.y;
	}

	double operator*(const Point & p)
	{
		return x * p.y - y * p.x;
	}

	double length() const
	{
		return mySqrt(*this % *this);
	}

	double distTo(const Point &p) const
	{
		return (*this - p).length();
	}

	double distTo(const Point & A, const Point & B) const
	{
		double d = A.distTo(B);
		if (doubleEqual(d, 0))
		{
			throw "A=B";
		}
		double s = (*this - A) * (*this - B);
		return fabs(s) / d;
	}

	Point normalize(double k = 1) const
	{
		double len = length();
		if (doubleEqual(len, 0))
		{
			if (doubleEqual(k, 0))
			{
				return Point();
			}
			throw "zero-size vector";
		}
		return *this * (k / len);
	}

	Point getH(const Point & A, const Point & B) const
	{
		Point C = *this;
		Point v = B - A;
		Point u = C - A;
		double k = v % u / v.length();
		v = v.normalize(k);
		Point H = A + v;
		return H;
	}

	Point rotate() const
	{
		return Point(-y, x);
	}

	Point rotate(double alpha) const
	{
		return rotate(cos(alpha), sin(alpha));
	}

	Point rotate(double cosa, double sina) const
	{
		Point v = *this;
		Point u = v.rotate();
		Point w = v * cosa + u * sina;
		return w;
	}

	bool isZero() const
	{
		return doubleEqual(x, 0) && doubleEqual(y, 0);
	}

	bool isOnLine(const Point & A, const Point & B) const
	{
		return doubleEqual((A - *this) * (B - *this), 0);
	}

	bool isInSegment(const Point & A, const Point & B) const
	{
		return isOnLine(A, B) && doubleLessOrEqual((A - *this) % (B - *this), 0);
	}

	bool isInSegmentStrictly(const Point & A, const Point & B) const
	{
		return isOnLine(A, B) && doubleLess((A - *this) % (B - *this), 0);
	}

	double getAngle() const
	{
		return atan2(y, x);
	}

	double getAngle(Point u) const
	{
		Point v = *this;
		return atan2(v * u, v % u);
	}
};

int getIntersection(const Point & A, const Point & B, const Point & C, const Point & D, Point & O)
{
	Point v = B - A;
	double s1 = (C - A) * (D - A);
	double s2 = (D - B) * (C - B);
	double s = s1 + s2;
	if (doubleEqual(s, 0))
	{
		if (!A.isOnLine(C, D))
			return 0;
		return 2;
	}
	v = v / s;
	v = v * s1;
	O = A + v;
	return 1;
}

int getIntersection(const Point & A, double rA, const Point & B, double rB, Point & M, Point & N)
{
	double d = A.distTo(B);
	if (doubleLess(rA + rB, d) || doubleLess(d, fabs(rA - rB)))
		return 0;
	double a = (sqr(rA) - sqr(rB) + sqr(d)) / 2 / d;
	double h = mySqrt(sqr(rA) - sqr(a));
	Point v = B - A;
	Point u = v.rotate();
	v = v.normalize(a);
	u = u.normalize(h);
	Point H = A + v;
	M = H + u;
	N - H - u;
	if (u.isZero())
		return 1;
	return 2;
}

double getS(Point p1, Point p2, Point p3)
{
	return fabs(((p2 - p1) * (p3 - p1)) / 2);
}

double check(Point p, Point p1, Point p2, Point p3)
{
	Point m1;
	vector < Point > v;
	v.pb(p1), v.pb(p2), v.pb(p3);
	bool flag = false;
	for (int i = 0; i < 3; i++)
	{
		getIntersection(Point(0, 0), p, v[i], v[(i + 1) % 3], m1);
		if (m1.isInSegmentStrictly(Point(0, 0), p) && m1.isInSegmentStrictly(v[i], v[(i + 1) % 3]))
		{
			flag = true;
		}
	}
	if (flag)
		return getS(p1, p2, p3);
	return 0;
}

int main()
{

	//freopen("a.in", "r", stdin);

	double x, y;
	cin >> x >> y;
	Point p(x, y);
	Point p1(10, 0), p2(0, 0), p3(10, 10);
	double ans = 0;
	for (int test = 0; test < 30; test++)
	{
		Point cur((p2.x + p3.x) / 2, (p2.y + p3.y) / 2);
		if (p.isInSegment(p1, cur))
		{
			ans += getS(p1, p2, p3) / 2;
			break;
		}
		if (p2.distTo(p) < p3.distTo(p))
		{
			ans += check(p, p1, p3, cur);
			p3 = p1;
			p1 = cur;
		}
		else
		{
			ans += check(p, p1, p2, cur);
			p2 = p1;
			p1 = cur;
		}
	}
	cout.precision(10);
	cout << fixed << ans << "\n";
	return 0;
}