#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>
#include <ctime>
#include <cassert>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back
#define y0 askjdfghjksdf
#define y1 askldjfahsd
#define fst first
#define snd second

template<typename T> T abs(T x) {if (x>=0) return x; return -x;}

bool cw(const pair < ll, ll > &a, const pair < ll, ll > &b, const pair < ll, ll > &c)
{
	return a.fst * (b.snd - c.snd) + b.fst * (c.snd - a.snd) + c.fst * (a.snd - b.snd) > 0;
}

bool ccw(const pair < ll, ll > &a, const pair < ll, ll > &b, const pair < ll, ll > &c)
{
	return a.fst * (b.snd - c.snd) + b.fst * (c.snd - a.snd) + c.fst * (a.snd - b.snd) < 0;
}

const int maxn = 100005;

int ans[maxn];

void hull(const vector < pair < pair < ll, ll >, int > > &a, int iter)
{
	if (a.size() == 1)
	{
		ans[a[0].snd] = iter;
		return;
	}

	vector < pair < pair < ll, ll >, int > > up, down;
	up.pb(a[0]);
	down.pb(a[0]);

	int n = a.size();

	for (int i = 1; i < n; i++)
	{
		if (i == n - 1 || !ccw(a[0].fst, a[i].fst, a[n - 1].fst))
		{
			while (down.size() > 1 && ccw(down[down.size() - 2].fst, down.back().fst, a[i].fst))
				down.pop_back();
			down.pb(a[i]);
		}

		if (i == n - 1 || !cw(a[0].fst, a[i].fst, a[n - 1].fst))
		{
			while (up.size() > 1 && cw(up[up.size() - 2].fst, up.back().fst, a[i].fst))
				up.pop_back();
			up.pb(a[i]);
		}
	}

	for (auto x : up)
		ans[x.snd] = iter;
	for (auto x : down)
		ans[x.snd] = iter;
}


int main()
{
	//freopen("a.in", "r", stdin);
	vector < pair < pair < ll, ll >, int > > a;

	int n;
	scanf("%d", &n);

	for (int i = 0; i < n; i++)
	{
		int x, y;
		scanf("%d %d", &x, &y);
		a.pb(mp(mp(x, y), i));
	}

	sort(a.begin(), a.end());

	int iter = 1;
	while (a.size() > 0)
	{
		hull(a, iter);
		iter++;

		vector < pair < pair < ll, ll >, int > >  b;
		for (auto x : a)
			if (!ans[x.snd])
				b.pb(x);

		a = b;
	}

	for (int i = 0; i < n; i++)
		printf("%d\n", ans[i]);

	return 0;
}