#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;
const double eps = 1e-4;

int cmp(double x, double y) {
	if (fabs(x-y) <= eps) return 0;
	if (x-y < 0) return -1;
	return 1;
}

double mySqrt(double x) {
	if (x < 0) return 0;
	return sqrt(x);
}

struct point {
	double x, y;
	point():x(0),y(0) {}
	point(double x, double y):x(x),y(y) {}
	point operator+(const point& o) const {
		return point(x+o.x,y+o.y);
	}
	point operator-(const point& o) const {
		return point(x-o.x,y-o.y);
	}
	point operator*(double k) const {
		return point(x*k,y*k);
	}
	double operator*(const point& o) const {
		return x*o.y-y*o.x;
	}
	double operator%(const point& o) const {
		return x*o.x+y*o.y;
	}
	double length() const {
		return mySqrt(*this % *this);
	}
	point setlength(double k = 1) const {
		return *this * (k/length());
	}
	void scan() {
		scanf("%lf%lf", &x, &y);
	}
	bool operator<(const point& o) const {
		if (cmp(x,o.x) != 0) return x < o.x;
		return cmp(y, o.y) < 0;
	}
	bool operator==(const point& o) const {
		return cmp(x,o.x)==0 && cmp(y,o.y)==0;
	}
	bool operator!=(const point& o) const {
		return !(*this == o);
	}
	double getangle(const point& u) const {
		point v = *this;
		return atan2(v*u, v%u);
	}

	bool insegment(point& A, point& B) {
		return cmp((A-*this)%(B-*this),0) <= 0;
	}
};

double det(double a11, double a12, double a21, double a22) {
	return a11*a22-a12*a21;
}

struct sp {
	double A, B, C;
	int ind;
	sp() {}
	sp(const point& p1, const point& p2) {
		A = p2.y-p1.y;
		B = p1.x-p2.x;
		C = -A*p1.x-B*p1.y;
		double r = sqrt(A*A+B*B);
		A/=r;
		B/=r;
		C/=r;

		////A*=-1;
		////B*=-1;
		////C*=-1;
	}
	double getval(const point& p) {
		return A*p.x+B*p.y+C;
	}
	point inters(const sp& o) const {
		double d = det(A,B,o.A,o.B);
		double d1 = det(-C,B,-o.C,o.B);
		double d2 = det(A,-C,o.A,-o.C);
		return point(d1/d,d2/d);
	}
};

vector<int> u;

bool calc(vector<sp> ss) {
	int n = sz(ss);
	forn(i, n) ss.pb(ss[i]);
	stack<sp> st;
	st.push(ss[0]);
	st.push(ss[1]);
	for (int i = 2; i < sz(ss); ++i) {
		sp cur = ss[i];
		while (sz(st) > 1) {
			sp pr = st.top(); st.pop();
			sp ppr = st.top();
			st.push(pr);
			point in = pr.inters(ppr);
			if (cmp(cur.getval(in), 0) < 0) st.pop();
			else break;
		}
		st.push(cur);
	}
	vector<sp> v;
	while (!st.empty()) v.pb(st.top()), st.pop();
	forn(ii, sz(v)) {
		sp cur = v[ii];
		if (u[cur.ind] != -1) {
			int fr = u[cur.ind];
			int to = ii;
			vector<sp> tmp(v.begin()+fr, v.begin()+(to+1));
			v = tmp;
		} else u[cur.ind] = ii;
	}
	if (sz(v) < 2) return false;
	point in = v[0].inters(v[1]);
	forn(i, sz(v)) if (cmp(v[i].getval(in),0) < 0) return false;
	vector<point> r;
	forn(i, sz(v)-1) r.pb(v[i].inters(v[i+1]));
	double S = 0;
	for(int i = 1; i < sz(r)-1; ++i) S += (r[i]-r[0])*(r[i+1]-r[0]);
	S = fabs(S)/2;
	return cmp(S,0) > 0;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int n; scanf("%d", &n);
	vector<point> v(n);
	forn(i, n) v[i].scan();
	forn(i, n) v.pb(v[i]);
	int l = 0;
	int r = n;
	while (r-l>1) {
		int m = (l+r)>>1;
		u = vector<int>(n,-1);
		vector<sp> ss;
		forn(i, n) ss.pb(sp(v[i], v[i+m+1])), ss.back().ind = i;
		bool res = calc(ss);
		if (res) l = m;
		else r = m;
	}
	printf("%d\n", r);
	return 0;
}
