#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

const double eps = 1e-9;

int cmp(double x, double y) {
	if (fabs(x-y) <= eps) return 0;
	if (x-y < 0) return -1;
	return 1;
}

double mySqrt(double x) {
	if (x < 0) return 0;
	return sqrt(x);
}

struct point {
	double x, y, z;
	point():x(0),y(0),z(0) {}
	point(double x, double y, double z):x(x),y(y),z(z) {}

	point operator+(const point& o) const {
		return point(x+o.x,y+o.y,z+o.z);
	}

	point operator-(const point& o) const {
		return point(x-o.x,y-o.y,z-o.z);
	}

	point operator*(double k) const {
		return point(x*k,y*k,z*k);
	}

	double length() const {
		return mySqrt(*this % *this);
	}

	double operator%(const point& o) const {
		return x*o.x+y*o.y+z*o.z;
	}
	point operator*(const point& o) const {
		return point(y*o.z-z*o.y, z*o.x-x*o.z, x*o.y-y*o.x);
	}

	point setlength(double k = 1) const {
		return *this * (k/length());
	}
	
	double disttoplane(const point& p1, const point& p2, const point& p3) const {
		point n = (p2-p1)*(p3-p1);
		n = n.setlength();
		double res = (*this - p1) % n;
		return fabs(res);
	}
};

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int m, h, H; scanf("%d%d%d", &m, &h, &H);
	vector<point> v(5);
	forn(i, 5) scanf("%lf%lf", &v[i].x, &v[i].y);
	v[0].z = h;
	v[4].z = H;
	swap(v[0], v[4]);
	double mind = 1e10;
	forn(i, 4) forn(j, i) forn(k, j) {
		point p1 = v[i];
		point p2 = v[j];
		point p3 = v[k];
		double curd = v[4].disttoplane(p1,p2,p3);
		mind = min(mind, curd);
	}
	m-=h;
	if (cmp(m, mind) < 0) printf("NO\n");
	else printf("YES\n");
	return 0;
}
