#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

const double eps = 1e-9;

int cmp(double x, double y) {
	if (fabs(x-y) <= eps) return 0;
	if (x-y < 0) return -1;
	return 1;
}

double mySqrt(double x) {
	if (x < 0) return 0;
	return sqrt(x);
}

struct point {
	double x, y;
	point():x(0),y(0) {}
	point(double x, double y):x(x),y(y) {}
	point operator+(const point& o) const {
		return point(x+o.x,y+o.y);
	}
	point operator-(const point& o) const {
		return point(x-o.x,y-o.y);
	}
	point operator*(double k) const {
		return point(x*k,y*k);
	}
	double operator*(const point& o) const {
		return x*o.y-y*o.x;
	}
	double operator%(const point& o) const {
		return x*o.x+y*o.y;
	}
	double length() const {
		return mySqrt(*this % *this);
	}
	point setlength(double k = 1) const {
		return *this * (k/length());
	}
	void scan() {
		scanf("%lf%lf", &x, &y);
	}
	bool operator<(const point& o) const {
		if (cmp(x,o.x) != 0) return x < o.x;
		return cmp(y, o.y) < 0;
	}
	bool operator==(const point& o) const {
		return cmp(x,o.x)==0 && cmp(y,o.y)==0;
	}
	bool operator!=(const point& o) const {
		return !(*this == o);
	}
	double getangle(const point& u) const {
		point v = *this;
		return atan2(v*u, v%u);
	}

	bool insegment(point& A, point& B) {
		return cmp((A-*this)%(B-*this),0) <= 0;
	}
};

struct tri {
	point A, B, C;
	tri(point A, point B, point C):A(A),B(B),C(C) {}
};

point F;

point inters(point A, point B, point C, point D) {
	point v = B-A;
	double s1 = (C-A)*(D-A);
	double s2 = (D-B)*(C-B);
	double s =s1+s2;
	v = v * (1/s);
	v = v * s1;
	return A+v;
}

bool interssegs(point A, point B, point C, point D, point& O) {
	point mid = inters(A,B,C,D);
	if (mid.insegment(A,B) && mid.insegment(C,D)) {O = mid; return true;}
	return false;
}



int IT = 0;

double solve(const tri& cur) {
	if (IT > 50) return 0;
	vector<point> v;
	point O;
	if (interssegs(point(0,0), F, cur.A, cur.B, O)) v.pb(O);
	if (interssegs(point(0,0), F, cur.B, cur.C, O)) v.pb(O);
	if (interssegs(point(0,0), F, cur.A, cur.C, O)) v.pb(O);
	sort(ALL(v));
	v.erase(unique(ALL(v)), v.end());
	if (sz(v) == 0) return 0;
	if (sz(v) == 2) return fabs((cur.A-cur.B)*(cur.C-cur.B))/2;
	if (sz(v) == 1) {
		point V = ((cur.A-cur.B)+(cur.C-cur.B))*.5;
		V = V + cur.B;
		++IT;
		double r1 = solve(tri(cur.A, V, cur.B));
		--IT;
		++IT;
		double r2 = solve(tri(cur.C, V, cur.B));
		--IT;
		return r1 + r2;
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	point A(0,0), B(10, 0), C(10, 10);
	F.scan();
	double res = solve(tri(A,B,C));
	printf("%.15lf\n", res);
	return 0;
}
