#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

const double eps = 1e-9;

int cmp(double x, double y) {
	if (fabs(x-y) <= eps) return 0;
	if (x-y < 0) return -1;
	return 1;
}

double mySqrt(double x) {
	if (x < 0) return 0;
	return sqrt(x);
}

struct point {
	double x, y;
	point():x(0),y(0) {}
	point(double x, double y):x(x),y(y) {}
	point operator+(const point& o) const {
		return point(x+o.x,y+o.y);
	}
	point operator-(const point& o) const {
		return point(x-o.x,y-o.y);
	}
	point operator*(double k) const {
		return point(x*k,y*k);
	}
	double operator*(const point& o) const {
		return x*o.y-y*o.x;
	}
	double operator%(const point& o) const {
		return x*o.x+y*o.y;
	}
	double length() const {
		return mySqrt(*this % *this);
	}
	point setlength(double k = 1) const {
		return *this * (k/length());
	}
	void scan() {
		scanf("%lf%lf", &x, &y);
	}
	bool operator<(const point& o) const {
		if (x != o.x) return x < o.x;
		return y < o.y;
	}
};


bool better(const point& v1, const point& v2) {
	if (v1.length() == 0) return false;
	if (v2.length() == 0) return true;
	double vect = v1 * v2;
	if (cmp(vect, 0) > 0) return true;
	if (cmp(vect, 0) == 0) {
		if (cmp(v1 % v2, 0) < 0) return true;
		return v1.length() < v2.length();
	}
	return false;
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int n; scanf("%d",&n);
	vector<point> v(n);
	forn(i, n) v[i].scan();
	vector<int> u(n);
	vector<int> ans(n);
	int cc = 0;
	int KK = 0;
	vector<int> inds;
	vector<int> pred(n);
	map<point, int> lst;
	int T = 0;
	forn(i, n) {
		pred[i] = i;
		if (!lst.count(v[i])) {
			inds.pb(i);
			lst[v[i]] = i;
			++T;
		} else {
			pred[i] = lst[v[i]];
		}
	}
	while (sz(inds)) {
		++KK;
		int id = 0;
		forn(ii, sz(inds)) {
			int cur = inds[ii];
			if (!u[cur] && (u[id] || (v[cur] < v[id]))) id = cur;
		}
		int frst = id;
		//u[id] = 1;
		ans[id] = KK;
		int cnt = 1;
		point vec(1,0);
		if (sz(inds) > 1) {
			while (true) {
				int nx = 0;
				forn(ii, sz(inds)) {
					int cur = inds[ii];
					if (!u[cur] && !(cmp(vec*(v[cur]-v[id]),0)==0 && cmp(vec%(v[cur]-v[id]),0)<0) && cur != id && (u[nx] || better(v[cur]-v[id],v[nx]-v[id]))) nx = cur;
				}
				vec = point(v[nx]-v[id]);
				id = nx;
				u[id] = 1;
				ans[id] = KK;
				++cnt;
				if (id == frst) break;
			}
		}
		if (sz(inds) == 1) break;
		vector<int> ninds;
		forn(ii, sz(inds)) {
			int cur = inds[ii];
			if (!u[cur]) ninds.pb(cur);
		}
		inds = ninds;
	}
	forn(i, n) printf("%d\n", ans[pred[i]]);
	return 0;
}
