#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e3+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

struct Point {
	public :
	double x, y;
	Point(){}
	Point (double _x, double _y){
		x = _x;
		y = _y;
	}
	double distTo(Point o){
		return sqrt(sqr(o.x - x) + sqr(o.y-y));
	}

	Point operator +(Point o){
		return Point(o.x + x, o.y + y);			
	}

	Point operator /(double d){
		return Point(x/d, y/d);
	}

	Point operator -(Point o){
		return Point(x-o.x, y-o.y);		
	}

	double operator *(Point o){
		return x*o.y - y*o.x;
	}

	bool operator == (Point o){
		return x == o.x && y == o.y;
	}

	void print(){
		printf("%.4f %.4f\n", x, y);
	}
};

vector < Point > v;
double total;
Point F;

bool onSegment(vector < Point > v, Point F){
	int ind1 = 0, ind2 = 0;
	double dist = -1.0;
	for (int i=0;i<3;i++){
		for (int j=i+1;j<3;j++){
			double distance = F.distTo(v[i]) + F.distTo(v[j]);
			if ( distance <= v[i].distTo(v[j]) ) return true;
		}
	}
	return false;
}

double Area(Point a, Point b, Point c){
	Point ab = b-a;
	Point ac = c-a;
	return abs(ab*ac);
}

bool inside(Point a, Point b, Point c, Point F){
	double s1 = Area(a, b, F);
	double s2 = Area(a, c, F);
	double s3 = Area(b, c, F);
	return s1 + s2 + s3 == Area(a, b, c);
}

bool strict_inside(Point a, Point b, Point c, Point F){
	double s1 = Area(a, b, F);
	double s2 = Area(a, c, F);
	double s3 = Area(b, c, F);
	return s1 + s2 + s3 == Area(a, b, c) && s1 > 0 && s2 > 0 && s3 > 0;
}

bool cross(Point a, Point b){
	return (F*a) * (F*b) <= 0 && ((b-a)*(F-a)) * ((b-a)*(Point(0,0)-a)) <= 0;	
}

bool intersects(Point a, Point b, Point c){
	bool ok = strict_inside(a, b, c, F);
	if ( a == F && cross(b, c) ) return true;
	if ( b == F && cross(a, c) ) return true;
	if ( c == F && cross(a, b) ) return true;
	return !ok && (cross(a, b) || cross(b, c) || cross(a, c));
}

void get(vector < Point > &v, Point F){
	vector < Point > res;		 	
	int ind1 = 0, ind2 = 0;
	double dist = -1.0;
	for (int i=0;i<3;i++){
		for (int j=i+1;j<3;j++){
			if ( v[i].distTo(v[j]) > dist ){
				dist = v[i].distTo(v[j]);
				ind1 = i; ind2 = j;
			}
		}
	}

	Point mid = (v[ind1] + v[ind2])/2;
	int ind3 = 3-ind1-ind2;
	res.pb(mid);
	res.pb(v[ind3]);
	if ( inside(v[ind1], v[ind3], mid, F) ){
		res.pb(v[ind1]);
		if ( intersects(v[ind2], mid, v[ind3]) )
			total += Area(v[ind2], mid, v[ind3])/2.0;
	}
	else {
		res.pb(v[ind2]);
		if ( intersects(v[ind1], mid, v[ind3]) )
			total += Area(v[ind1], mid, v[ind3])/2.0;
	}
	v = res;
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	cin >>F.x>>F.y;

	v.pb(Point(0,0));
	v.pb(Point(10,10));
	v.pb(Point(10, 0));

	for (int iter=0;iter<10000;iter++){
		if ( onSegment(v, F)) break;
		get(v, F);	    
	}

	printf("%.9f", total);


	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}


