#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "a"

struct pt
{
	ld x, y, z;
	
	pt(): x(0), y(0) {}
	
	pt(ld x, ld y): x(x), y(y) {}
	
	ld operator%(const pt &a) const
	{
		return x * a.y - y * a.x;
	}
	
	ld operator*(const pt &a) const
	{
		return x * a.x + y * a.y;
	}
	
	pt operator-(const pt &a) const
	{
		return pt(x - a.x, y - a.y);
	}
	
	pt operator+(const pt &a) const
	{
		return pt(x + a.x, y + a.y);
	}
	
	pt operator/(const ld a) const
	{
		return pt(x / a, y / a);
	}
	
};

pt a[1001];
vector <pt> v;
pt up[100001];
pt down[100001];

#define EPS 1e-10

inline bool eq(const ld &a, const ld &b)
{
	return fabsl(a - b) < EPS;
}

bool cmp(const pt &a, const pt &b)
{
	return (!eq(a.x, b.x) && a.x < b.x) || (eq(a.x, b.x) && a.y < b.y);
}

ld calc(pt *a, int n)
{
//	cerr << n << '\n';
//	for (int i = 0; i < n; ++i)
//		cerr << a[i].x << ' ' << a[i].y << '\n';
	ld res = 0;
	for (int i = 1; i + 1 < n; ++i)
		res += ((a[i] - a[0]) % (a[i + 1] - a[0]));
	return fabsl(res) / 2;
}

int main()
{
	cout.precision(10);
	cout.setf(ios::fixed);
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	int n, zmin, zmax;
	cin >> n >> zmin >> zmax;
	for (int i = 0; i < n; ++i)
	{
		int x, y, z;
		scanf("%d%d%d", &x, &y, &z);
		a[i] = pt(x, y);
		a[i].z = z;
	}
	for (int z = zmin; z <= zmax; ++z)
	{
//		cerr << "Z: " << z << '\n';
		v.clear();
		for (int i = 0; i < n; ++i)
			if (a[i].z == z)
				v.pb(a[i]);
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < n; ++j)
			{
				if (a[i].z >= z)
					continue;
				if (a[j].z <= z)
					continue;
				ld z1 = a[i].z;
				ld z2 = a[j].z;
				pt c = a[i] + (a[j] - a[i]) / ((z2 - z1) / (z - z1));
				v.pb(c);
			}
		sort(v.begin(), v.end(), cmp);
//		cerr << sz(v) << '\n';
//		for (int i = 0; i < sz(v); ++i)
//			cerr << v[i].x << ' '<< v[i].y << '\n';
		int uc = 0, dc = 0;
		
		for (int i = 0; i < sz(v); ++i)
		{
			pt &c = v[i];
			while (uc > 1)
			{
				if ((c - up[uc - 2]) % (up[uc - 1] - up[uc - 2]) > EPS)
					break;
				--uc;
			}
			while (dc > 1)
			{
				if ((c - down[dc - 2]) % (down[dc - 1] - down[dc - 2]) < -EPS)
					break;
				--dc;
			}
			down[dc++] = c;
			up[uc++] = c;
		}
		--uc;
		reverse(up, up + uc);
		--uc;
		for (int i = 0; i < uc; ++i)
			down[dc++] = up[i];
//		cerr << dc << '\n';
//		for (int i = 0; i < dc; ++i)
//			cerr << down[i].x << ' ' << down[i].y << '\n';
//		cerr << "________\n";
		cout << calc(down, dc) << '\n';
	}
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
