#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "d"

struct pt
{
	ld x, y;
	
	pt(): x(0), y(0) {}
	
	pt(ld x, ld y): x(x), y(y) {}
	
	ld operator%(const pt &a) const
	{
		return x * a.y - y * a.x;
	}
	
	ld operator*(const pt &a) const
	{
		return x * a.x + y * a.y;
	}
	
	pt operator-(const pt &a) const
	{
		return pt(x - a.x, y - a.y);
	}
	
	pt operator+(const pt &a) const
	{
		return pt(x + a.x, y + a.y);
	}
	
	pt operator/(const ld a) const
	{
		return pt(x / a, y / a);
	}
	
};

pt a[200001];
int n;

#define EPS 1e-7

const ld MAGIC = 10000000;
vector <pair <pt, pt> > line;
pt P;

pt intersect(const pt &a, const pt &b, const pt &c, const pt &d)
{
	ld s1 = (c - a) % (d - a);
	ld s = (c - d) % (b - a);
	return a + (b - a) / (s / s1);
}

bool ok(pt a, pt b, pt c)
{
	return (c - a) % (b - a) >= -EPS;
}

bool add_line(pt a, pt b)
{
//	cerr << "add line " << a.x << ' ' << a.y << ' ' << b.x << ' ' << b.y << '\n';
	line.pb(mp(a, b));
	if (ok(a, b, P))
		return true;
	if (fabsl((b - a) % (line[0].se - line[0].fi)) < EPS)
		P = intersect(a, b, line[1].fi, line[1].se);
	else
		P = intersect(a, b, line[0].fi, line[0].se);
	assert(ok(a, b, P));
//	cerr << P.x << ' ' << P.y << '\n';
	for (int i = 0; i < sz(line) - 1; ++i)
	{
		pt c = line[i].fi;
		pt d = line[i].se;
		if (fabsl((b - a) % (d - c)) < EPS)
			continue;
		if (ok(c, d, P))
			continue;
		pt f = intersect(a, b, c, d);
		P = f;
	}
//	cerr << "Ans = " << P.x << " " << P.y << endl;
	for (int i = 0; i < sz(line); ++i)
		if (!ok(line[i].fi, line[i].se, P))
			return false;
	return true;
}

vector <pair <pt, pt> > v;
bool check(int c)
{
	line.clear();
	P = pt(0, MAGIC);
	line.pb(mp(pt(0, MAGIC), pt(MAGIC, 0)));
	line.pb(mp(pt(-MAGIC, 0), pt(0, MAGIC)));
	v.clear();
	for (int i = 0; i < n; ++i)
	{
		v.pb(mp(a[i], a[i + c - 1]));
//		cerr << a[i].x << ' ' << a[i].y << ' ' << a[i + c - 1].x << ' ' << a[i + c - 1].y << '\n';
	}
	random_shuffle(v.begin(), v.end());
	for (int i = 0; i < n; ++i)
		if (!add_line(v[i].fi, v[i].se))
			return true;
	return false;
}

int main()
{
	srand(30010);
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	cin >> n;
	for (int i = 0; i < n; ++i)
	{
		int x, y;
		scanf("%d%d", &x, &y);
		a[i] = pt(x, y);
	}
	reverse(a, a + n);
	for (int i = 0; i < n; ++i)
		a[i + n] = a[i];
	int lb = 0, rb = n - 2;
//	for (int i = 3; i < n; ++i)
//		cerr << i << ' ' << check(i) << '\n';
//	cerr << check(4) << '\n';
//	return 0;
	while (lb + 1 < rb)
	{
		int c = (lb + rb) / 2;
//		cerr << "delete " << c << ' ' << check(n - c) << '\n';
		if (check(n - c))
			rb = c;
		else
			lb = c;
	}
	cout << rb << '\n';
	
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
