#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "f"

struct pt
{
	ld x, y, z;
	
	pt(ld nx = 0, ld ny = 0, ld nz = 0): x(nx), y(ny), z(nz) {}
	
	ld operator*(const pt &a) const
	{
		return x * a.x + y * a.y + z * a.z;
	}
	
	pt operator%(const pt &p) const
	{
		return pt(y * p.z - z * p.y, 
				  z * p.x - x * p.z,
				  x * p.y - y * p.x);
	}
	
	pt operator-(const pt &p) const
	{
		return pt(x - p.x, y - p.y, z - p.z);
	}
	
	ld operator ~() const
	{
		return sqrtl((*this) * (*this));
	}
};

ld dist(pt p, pt a, pt b, pt c)
{
	pt n = (b - a) % (c - a);
	return fabs(n * (p - a) / ~n);
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	int m, h, H;
	pt pts[5];
	cin >> m >> h >> H;
	for (int i = 0; i <= 4; ++i)
	{
		cin >> pts[i].x >> pts[i].y;
		pts[i].z = (i == 0 ? h : (i == 4 ? H : 0));
	}
	ld d1 = dist(pts[0], pts[1], pts[2], pts[3]);
	ld d2 = dist(pts[0], pts[1], pts[2], pts[4]);
	ld d3 = dist(pts[0], pts[1], pts[3], pts[4]);
	ld d4 = dist(pts[0], pts[2], pts[3], pts[4]);
//	cerr << d1 << " " << d2 << " " << d3 << " " << d4 << endl;
	if (min(min(d1, d2), min(d3, d4)) + h > m)
		cout << "NO" << endl;
	else
		cout << "YES" << endl;
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}

