#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "g"

struct pt
{
	ld x, y;
	
	pt(): x(0), y(0) {}
	
	pt(ld x, ld y): x(x), y(y) {}
	
	ld operator%(const pt &a) const
	{
		return x * a.y - y * a.x;
	}
	
	ld operator*(const pt &a) const
	{
		return x * a.x + y * a.y;
	}
	
	pt operator-(const pt &a) const
	{
		return pt(x - a.x, y - a.y);
	}
	
	pt operator+(const pt &a) const
	{
		return pt(x + a.x, y + a.y);
	}
	
	pt operator/(const ld a) const
	{
		return pt(x / a, y / a);
	}
	
	ld abs() const
	{
		return sqrtl(x * x + y * y);
	}
	
};

pt P;

#define EPS 1e-10

bool intersect(pt A, pt B, pt C, pt D)
{
//	cerr << A.x << ' ' << A.y << '\n';
//	cerr << B.x << ' ' << B.y << '\n';
//	cerr << C.x << ' ' << C.y << '\n';
//	cerr << D.x << ' ' << D.y << '\n';
	ld s1 = (B - A) % (C - A);
	ld s2 = (B - A) % (D - A);
	if (fabsl(s1) > EPS && fabsl(s2) > EPS)
	{
		if (s1 < 0 && s2 < 0)
			return false;
		if (s1 > 0 && s2 > 0)
			return false;
	}
	swap(A, C);
	swap(B, D);
	s1 = (B - A) % (C - A);
	s2 = (B - A) % (D - A);
	if (fabsl(s1) > EPS && fabsl(s2) > EPS)
	{
		if (s1 < 0 && s2 < 0)
			return false;
		if (s1 > 0 && s2 > 0)
			return false;
	}
	return true;
}

pt intersection(pt A, pt B, pt C, pt D)
{
	ld s1 = (C - A) % (D - A);
	ld s = (C - D) % (B - A);
	return A + (B - A) / (s / s1);
}

ld sqr2(pt A, pt B, pt C)
{
	return fabsl((B - A) % (C - A));
}

bool intriangle(pt P, pt A, pt B, pt C)
{
	ld s = sqr2(P, A, B) + sqr2(P, A, C) + sqr2(P, B, C);
	return fabsl(s - sqr2(A, B, C)) < EPS;
}

ld calc(pt A, pt B, pt C, ld s)
{
//	cerr << A.x << ' ' << A.y << ' ' << B.x << ' ' << B.y << ' ' << C.x << ' ' << C.y << '\n';
	if (s < EPS)
		return 0;
	pt D = (A + B) / 2;
	if (fabsl((D - C) % (P - C)) < EPS)
		return s / 2;
	ld res = 0;
	if (intersect(pt(0, 0), P, C, D))
	{
		pt SUKA = intersection(pt(0, 0), P, C, D);
		if ((SUKA - C).abs() > EPS && (SUKA - D).abs() > EPS)
			res += s / 2;
	}
	if (intriangle(P, A, C, D))
		res += calc(A, C, D, s / 2);
	else
		res += calc(B, C, D, s / 2);
	return res;
}

int main()
{
	cout.precision(10);
	cout.setf(ios::fixed);
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	ld x, y;
	cin >> x >> y;
	P = pt(x, y);
	cout << calc(pt(0, 0), pt(10, 10), pt(10, 0), 50) << '\n';
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
