#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <stack>
#include <algorithm>

using namespace std;

#define sqr(x) ((x) * (x))

class point{
public:
    int x, y, ind;
    point() {}
    point(int _x, int _y) {
        x = _x;
        y = _y;
    }
    bool operator<(const point & a) const {
        return (ind < a.ind);
    }
    point operator-(const point & a) const {
        return point(x - a.x, y - a.y);
    }
    int operator%(const point & p) {
        return x * p.x + y * p.y;
    }
    int operator*(const point & p) {
        return x * p.y - y * p.x;
    }
    int distTo2(const point & p) {
        return sqr(x - p.x) + sqr(y - p.y);
    }
};

vector<point> a;
vector<int> ans;
vector<bool> used;

int my = 1e9;
int mx = 1e9;
point mp;

bool cmp(const point & a, const point & b) {
    if (used[a.ind] != used[b.ind]) return a.ind < b.ind;
    if ((a - mp) * (b - mp) == 0)
        return mp.distTo2(a) < mp.distTo2(b);
    return (a - mp) * (b - mp) < 0;
}

bool cmp2(const point & a, const point & b) {
    return a.x < b.x;
}

bool sorted = false;

vector<point> buildConvex() {
    my = 1e9;
    mx = 1e9;
    int ind = -1;
    int zero_index = -1;

    for (int i = 0; i < a.size(); ++i) {
        if (used[a[i].ind] == true) continue;
        else if (zero_index == -1) zero_index = i;
        if (a[i].y < my) my = a[i].y, mx = a[i].x, ind = i;
        if (a[i].y == my && mx > a[i].x) mx = a[i].x, ind = i;
    }

    swap(a[zero_index], a[ind]);

    mp = point(mx, my);

    if (!sorted) {
        sort(a.begin() + 1, a.end(), cmp);
        sorted = true;
    }
/*
    cerr << "_______" << endl;
    for (int i = 0; i < a.size(); ++i)
        cerr << a[i].x << " " << a[i].y << " " << a[i].ind << endl;
    cerr << "_______" << endl;
*/
    vector<point> st;
    st.push_back(a[zero_index]);

    for (int i = zero_index + 1; i < a.size(); ++i) {
        if (used[a[i].ind] == true) continue;
        while (st.size() > 1 && (st[st.size() - 1] - st[st.size() - 2]) * (a[i] - st[st.size() - 1]) > 0)
            st.pop_back();
        st.push_back(a[i]);
    }

//    cerr << st.size() << endl;

     while (st.size() > 1 && (st[st.size() - 1] - st[st.size() - 2]) * (a[zero_index] - st[st.size() - 1]) > 0)
        st.pop_back();

//    cerr << st.size() << endl;

    swap(a[zero_index], a[ind]);

    return st;
}

vector<point> buildConvex2() {
    point left(1e9, 1e9), right(-1e9, -1e9);

    for (int i = 0; i < a.size(); ++i) {
        if (used[a[i].ind] == true) continue;
        if (a[i].x < left.x)
            left = a[i];
        if (a[i].x >= right.x)
            right = a[i];
    }

//    cerr << left.x << " " << left.y << endl;
//    cerr << right.x << " " << right.y << endl;

    vector<point> st_up, st_low;
    st_up.push_back(left);
    st_low.push_back(left);

    for (int i = 0; i < a.size(); ++i) {
        if (used[a[i].ind] == true || a[i].ind == left.ind || a[i].ind == right.ind) continue;
        if ((right - left) * (a[i] - left) <= 0) {
            while (st_up.size() > 1 && (st_up[st_up.size() - 1] - st_up[st_up.size() - 2]) * (a[i] - st_up[st_up.size() - 1]) < 0)
                st_up.pop_back();
            st_up.push_back(a[i]);
        } else if ((right - left) * (a[i] - left) >= 0) {
            while (st_low.size() > 1 && (st_low[st_low.size() - 1] - st_low[st_low.size() - 2]) * (a[i] - st_low[st_low.size() - 1]) > 0)
                st_low.pop_back();
            st_low.push_back(a[i]);
        }
    }

    while (st_up.size() > 1 && (st_up[st_up.size() - 1] - st_up[st_up.size() - 2]) * (right - st_up[st_up.size() - 1]) < 0)
        st_up.pop_back();
    if (left.ind != right.ind)
        st_up.push_back(right);
    while (st_low.size() > 1 && (st_low[st_low.size() - 1] - st_low[st_low.size() - 2]) * (right - st_low[st_low.size() - 1]) > 0)
        st_low.pop_back();

/*    cerr << "st_low == ";
    for (int i = 0; i < st_low.size(); ++i)
        cerr << st_low[i].ind << " ";
    cerr << endl;
*/

    for (int i = 1; i < st_low.size(); ++i)
        st_up.push_back(st_low[i]);
/*
    cerr << "ans == ";
    for (int i = 0; i < st_up.size(); ++i)
        cerr << st_up[i].ind << " ";
    cerr << endl;
*/
    return st_up;
}

int main()
{
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    a.resize(n);
    ans.resize(n);
    used.resize(n, false);

    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
        a[i].ind = i;
    }

    int color = 1;

    int counter = 0;

/*    while (counter < n) {
//        cerr << counter << endl;
        vector<point> b = buildConvex();
//        set<point> z;
        for (int i = 0; i < b.size(); ++i) {
            ans[b[i].ind] = color;
            used[b[i].ind] = true;
            ++counter;
//            cerr << b[i].x << " " << b[i].y << endl;
//            z.insert(b[i]);
        }
/*        vector<point> c;
        for (int i = 0; i < a.size(); ++i)
            if (z.find(a[i]) == z.end())
                c.push_back(a[i]);
        a = c;*/
//        color++;
//        break;
//    }
    sort(a.begin(), a.end(), cmp2);
    while (counter < n) {
        vector<point> b = buildConvex2();
        for (int i = 0; i < b.size(); ++i) {
            ans[b[i].ind] = color;
            used[b[i].ind] = true;
            ++counter;
        }
        ++color;
    }

    for (int i = 0; i < n; ++i)
        cout << ans[i] << "\n";

    return 0;
}
