#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li


ld eps = 1e-9;

struct Point {
	ld x, y, z;

	Point() {
	}

	Point(ld x, ld y, ld z):x(x), y(y), z(z) {
	}

	ld operator [] (int c) const {
		switch(c) {
		case 0 : 
			return x;
			break;
		case 1:
			return y;
			break;
		case 2:
			return z;
			break;
		default:
			assert(false);
		}
	}

	Point operator - (const Point& p)const {
		return Point(x - p.x, y - p.y, z - p.z);
	}

	Point operator + (const Point& p)const {
		return Point(x + p.x, y + p.y, z + p.z);
	}

	bool operator < (const Point& p) const{
		return x < p.x || x == p.x && mp(y, z) < mp(p.y, p.z);
	}

	Point operator * (const Point& p) const{
		return Point(y * p.z - z * p.y, z * p.x - x * p.z, x * p.y - y * p.x);
	}

	ld operator % (const Point& p) const {
		return x * p.x + y * p.y + z * p.z;
	}

	ld sqrDist() const {
		return x * x + y * y + z * z;
	}

	void scan() {
		cin >> x >> y >> z;
	}

	Point operator * (ld c) const {
		return Point(x * c, y * c, z * c);
	}

	ld dist() const {
		return sqrt(x * x + y * y + z * z);
	}

};

struct Comparator {
	const vector<Point>& points;
	Point center;
	int id;

	Comparator(vector<Point>& points, Point center, int id): points(points), center(center), id(id) {
	}


	bool operator() (int q, int w) {
		Point curL = points[q] - center;
		Point curR = points[w] - center;
		vector<ld> L, R;
		for (int i = 0; i < 3; ++i)
			if (i != id) {
				L.push_back(curL[i]);
				R.push_back(curR[i]);
			}
		return atan2(L[1], L[0]) + eps < atan2(R[1], R[0]);
	}
};

struct polyhedron {
	int n;
	vector<Point> points;
	set<vector<int>> faces;

	vector<vector<int>> triangles;

	void scan() {
		cin >> n;
		points.resize(n);
		for (int i = 0; i < n; ++i)
			points[i].scan();
	}

	void boreFaces() {
		
		for (int i = 0; i < n; ++i)
			for (int j = i + 1; j < n; ++j)
				for (int k = j + 1; k < n; ++k) {
					Point normal = (points[j] - points[i]) * (points[k] - points[i]);

					ld D = -(normal % points[i]);

					vector<int> curFace;

					for (int z = 0; z < n; ++z)
						if (fabs((normal % points[z]) + D) < eps)
							curFace.push_back(z);

					sort(all(curFace));

					set<int> signums;
					for (int z = 0; z < n; ++z) {
						if (((normal % points[z]) + D) < -eps)
							signums.insert(-1);
						if (((normal % points[z]) + D) > eps)
							signums.insert(1);
					}

					if (signums.size() <= 1)
						faces.insert(curFace);
				}
	}



	void triangularFaces() {
		for (set<vector<int>>::iterator it = faces.begin(); it != faces.end(); ++it) {
			vector<int> curFace = *it;

			Point center(0, 0, 0);
			for (int i = 0; i < curFace.size(); ++i)
				center = center + points[curFace[i]];

			center = center * (1.0 / curFace.size());

			bool sorted = false;

			for (int i = 0; i < 3; ++i) {
				ld value = points[curFace[0]][i];
				bool flag = false;
				for (int j = 0; j < curFace.size(); ++j)
					if (fabs(points[curFace[j]][i] - value) > 1e-9) {
						flag = true;
						break;
					}
				if (!flag) {
					sort(all(curFace), Comparator(points, center, i));
					sorted = true;
					break;
				}
			}

			if (!sorted) {
				sort(all(curFace), Comparator(points, center, 2));
			}

			for (int i = 1; i + 1 < curFace.size(); ++i) {
				vector<int> toAdd;
				toAdd.push_back(curFace[0]);
				toAdd.push_back(curFace[i]);
				toAdd.push_back(curFace[i + 1]);
				triangles.push_back(toAdd);
			}

		}
	}

	ld getV(Point c, Point p0, Point p1, Point p2) const {
		return fabs( ((p0 - c) * (p1 - c)) % (p2 - c) );
	}

	Point boreTetrahedra() {
		Point center(0, 0, 0);
		for (int i = 0; i < n; ++i)
			center = center + points[i];
		center = center * (1.0 / n);

		Point ans(0, 0, 0);

		ld sumV = 0;

		for (int i = 0; i < triangles.size(); ++i) {
			Point curCenter = center;
			for (int j = 0; j < 3; ++j)
				curCenter = curCenter + points[triangles[i][j]];
			curCenter = curCenter * (1.0 / 4);

			ld curV = getV(center, points[triangles[i][0]], points[triangles[i][1]], points[triangles[i][2]]);

			//cout << curCenter.x << ' ' << curCenter.y << ' ' << curCenter.z << ' ' << curV << endl;

			ans = ans + (curCenter - center) * curV;

			sumV += curV;
		}

		ans = ans * (1.0 / sumV);
		ans = ans + center;

		return ans;
	}

	ld getDist(Point center) {
		ld ans = 1e18;

		for (int i = 0; i < triangles.size(); ++i) {
			ld curV = getV(center, points[triangles[i][0]], points[triangles[i][1]], points[triangles[i][2]]);
			ld curS = ((points[triangles[i][2]] - points[triangles[i][0]]) * (points[triangles[i][1]] - points[triangles[i][0]])).dist();
			ans = min(ans, curV / curS);
		}

		return ans;

	}

};

polyhedron poly[2];

void solve() {
	vector<ld> minD(2, 1e18);
	for (int w = 0; w < 2; ++w) {
		poly[w].scan();
		poly[w].boreFaces();
		poly[w].triangularFaces();
		Point center = poly[w].boreTetrahedra();
		ld minDist = poly[w].getDist(center);
		minD[w] = min(minD[w], minDist);
		//return;
	}


	cout << minD[0] + minD[1];


}