#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

#define EPS (1e-7)

inline double min(double a, double b, double c, double d) {
	return min(a, min(b, min(c, d)));
}

inline double sqr(double a) {
	return a * a;
}

struct point {
	double x, y, z;

	void read() {
		cin >> x >> y >> z;
	}
};

struct matr {
	matr() { }
	matr(double a11, double a12, double a13, double a21, double a22, double a23, double a31, double a32, double a33) {
		a[1][1] = a11;
		a[1][2] = a12;
		a[1][3] = a13;
		a[2][1] = a21;
		a[2][2] = a22;
		a[2][3] = a23;
		a[3][1] = a31;
		a[3][2] = a32;
		a[3][3] = a33;
	}
	double a[4][4];
};

double det(matr a) {
	return a.a[1][1] * (a.a[2][2] * a.a[3][3] - a.a[2][3] * a.a[3][2])
		- a.a[1][2] * (a.a[2][1] * a.a[3][3] - a.a[2][3] * a.a[3][1]) + a.a[1][3] * (a.a[2][1] * a.a[3][2] - a.a[2][2] * a.a[3][1]);
}

struct plane {
	plane() {}
	plane(double _a, double _b, double _c, double _d) {
		a = _a, b = _b, c = _c, d = _d;
	}
	plane(point _a, point _b, point _c) {
		
		plane res;

		a = 1;
		matr maina(_a.y, _a.z, 1, _b.y, _b.z, 1, _c.y, _c.z, 1);
		double mainadet = det(maina);
		if (fabs(mainadet) > EPS) {
			b = det(matr(-_a.x, _a.z, 1, -_b.x, _b.z, 1, -_c.x, _c.z, 1)) / mainadet;
			c = det(matr(_a.y, -_a.x, 1, _b.y, -_b.x, 1, _c.y, -_c.x, 1)) / mainadet;
			d = det(matr(_a.y, _a.z, -_a.x, _b.y, _b.z, -_b.x, _c.y, _c.z, -_c.x)) / mainadet;
			return;
		}

		b = 1;
		matr mainb(_a.x, _a.z, 1, _b.x, _b.z, 1, _c.x, _c.z, 1);
		double mainbdet = det(mainb);
		if (fabs(mainbdet) > EPS) {
			a = det(matr(-_a.y, _a.z, 1, -_b.y, _b.z, 1, -_c.y, _c.z, 1)) / mainbdet;
			c = det(matr(_a.x, -_a.y, 1, _b.x, -_b.y, 1, _c.x, -_c.y, 1)) / mainbdet;
			d = det(matr(_a.x, _a.z, -_a.y, _b.x, _b.z, -_b.y, _c.x, _c.z, -_c.y)) / mainbdet;
			return;
		}

		c = 1;
		matr mainc(_a.x, _a.y, 1, _b.x, _b.y, 1, _c.x, _c.y, 1);
		double maincdet = det(mainc);
		if (fabs(maincdet) > EPS) {
			a = det(matr(-_a.z, _a.y, 1, -_b.z, _b.y, 1, -_c.z, _c.y, 1)) / maincdet;
			b = det(matr(_a.x, -_a.z, 1, _b.x, -_b.z, 1, _c.x, -_c.z, 1)) / maincdet;
			d = det(matr(_a.x, _a.y, -_a.z, _b.x, _b.y, -_b.z, _c.x, _c.y, -_c.z)) / maincdet;
			return;
		}
	}
	double a, b, c, d;
};

inline double dist(point a, plane b) {
	return fabs((b.a * a.x + b.b * a.y + b.c * a.z + b.d) / sqrt(sqr(b.a) + sqr(b.b) + sqr(b.c)));
}

double m;
point a, b, c, d, x;

int main()
{


	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	cin >> m >> x.z >> d.z;
	cin >> x.x >> x.y;
	cin >> a.x >> a.y;
	cin >> b.x >> b.y;
	cin >> c.x >> c.y;
	cin >> d.x >> d.y;
	a.z = b.z = d.z = 0;
	plane q(a, b, c);
	cerr.setf(ios::fixed);
	cerr.precision(3);
	cerr << q.a << ' ' << q.b << ' ' << q.c << ' ' << q.d << endl;
	cerr << dist(x, plane(a, b, c)) << endl;

	double res = x.z;
	double r = 0;
	res += min(dist(x, plane(a, b, c)), dist(x, plane(a, b, d)), dist(x, plane(b, c, d)), dist(x, plane(a, c, d)));
	if (m - res > EPS) 
		cout << "YES" << endl;
	else
		cout << "NO" << endl;
}