#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <string>

#define fore(i, a, b) for(int i = (int)(a); i <= (int)(b); ++i)
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long double ld;
typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int u32;
typedef vector<pii> vpi;

const ld eps = 1e-9;
inline bool eq(ld x, ld y)
{
	return fabsl(x - y) < eps;
}
inline bool le(ld x, ld y)
{
	return y - x > eps;
}
inline bool gr(ld x, ld y)
{
	return x - y > eps;
}
struct Pt
{
	ld x, y;
	Pt() {}
	Pt(ld x, ld y): x(x),y(y){}
	Pt operator + (const Pt& p) const
	{
		return Pt(x + p.x, y + p.y);
	}
	Pt operator - (const Pt& p) const
	{
		return Pt(x - p.x, y - p.y);
	}
	Pt operator * (ld k) const 
	{
		return Pt(x * k, y * k);
	}
	ld operator * (const Pt& p) const
	{
		return x * p.y - y * p.x;
	}
	ld operator ^ (const Pt& p) const
	{
		return x * p.x + y * p.y;
	}
	Pt operator - ()
	{
		return Pt(-x, -y);
	}
	void print() const
	{
		cout << x << " " << y << endl;
	}
	void read()
	{
		cin >> x >> y;
	}
	Pt rotate(ld ang) const
	{
		return Pt(x*cos(ang)-y*sin(ang), x*sin(ang) + y*cos(ang));
	}
	bool operator < ( const Pt& o) const { return mp(x, y) < mp(o.x, o.y); }
};

const int N = 2 * 10000 + 10;
Pt a[N];

struct cmp {
	bool operator()(int i, int j) {
		return a[i] < a[j];
	}
};

struct Pt3
{
	Pt p;
	ld z;
	void read()
	{
		cin >> p.x >> p.y >> z;
	}
	bool operator < (const Pt3& p) const
	{
		return z < p.z - eps;
	}
};

ld solve(int n)
{
	static int up[N];
	static int down[N];
	static int pts[N];
	static Pt ans[N];
	forn(i, n) pts[i] = i;
	sort(pts, pts + n, cmp());

	int sans = 0;
	int sup, sdown;
	sup = sdown = 0;
	forn(i, n) {
		while( sup > 1 && (a[up[sup-1]] - a[up[sup-2]]) * (a[pts[i]] - a[up[sup-2]]) >= 0 )
			--sup;
		up[sup++] = pts[i];
		while( sdown > 1 && (a[down[sdown-1]] - a[down[sdown-2]]) * (a[pts[i]] - a[down[sdown-2]]) <= 0 )
			--sdown;
		down[sdown++] = pts[i];
	}
	if( sup + sdown - 2 <= 2 ) return 0.0;
	forn (i, sup)
		ans[sans++] = a[up[i]];
	for(int i = sdown - 2; i >= 1; --i)
		ans[sans++] = a[down[i]];
	ld res = 0;
	forn (i, sans)
		res += ans[i] * ans[(i+1)%sans];
	return fabs(res) / 2;
}


int main() {
	cin.sync_with_stdio();
	cin.tie(0);
	cout.precision(12);
	cout << fixed;
	cerr.precision(12);
	cerr << fixed;
#ifdef HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n, mnZ, mxZ;
	cin >> n >> mnZ >> mxZ;
	vector<Pt3> in(n);
	forn (i, n)
	{
		in[i].read();
	}
	sort(all(in));
	
	fore (z, mnZ, mxZ)
	{
		int q = 0;
		forn (i, n)
			if (eq(in[i].z, z))
				a[q++] = in[i].p;
		forn (i, n)
			forn (j, i)
		if (in[j].z < z - eps && in[i].z > z + eps)
		{
			Pt diff = in[i].p - in[j].p;
			Pt cur = in[j].p + diff * ((z - in[j].z) / (in[i].z - in[j].z));
			a[q++] = cur;
		}
		cout << solve(q) << "\n";
	}
	return 0;
}
