#include <bits/stdc++.h>

using namespace std;

#define double long double

const double EPS = 1e-6;

struct point
{
    double x, y, num;
    point(){}
    point(double x, double y): x(x), y(y){}
};

struct triangle
{
    point a, b, c;
    triangle(){}
    triangle(point a, point b, point c):a(a), b(b), c(c){}
};

point operator - (point a, point b)
{
    return point(a.x - b.x, a.y - b.y);
}

double operator * (point a, point b)
{
    return a.x * b.y - a.y * b.x;
}
double operator % (point a, point b)
{
    return a.x * b.x + a.y * b.y;
}


struct line
{
    double A, B, C;
    line(){}
    line(double A, double B, double C):A(A), B(B), C(C){}
};

bool ok;

pair<triangle, triangle> divide(triangle t, point f)
{
    point n((t.a.x + t.b.x) / 2, (t.a.y + t.b.y) / 2);
    line h(t.c.y - n.y, n.x - t.c.x,n.y*t.c.x - t.c.y*n.x);
    ok = fabs(h.A * f.x + h.B * f.y + h.C) <= EPS;
    bool fp = h.A * f.x + h.B * f.y + h.C <= EPS;
    bool ap = h.A * t.a.x + h.B * t.a.y + h.C <= EPS;
    if(!(fp ^ ap))
        return {triangle(t.a, t.c, n), triangle(t.b, t.c, n)};
    else
        return {triangle(t.b, t.c, n), triangle(t.a, t.c, n)};
}

bool check(triangle t, point f)
{
    double k = f.x / f.y;
    double x0 = t.a.x, y0 = t.a.y, x1 = t.b.x, y1 = t.b.y, x2 = t.c.x, y2 = t.c.y;
    assert((k *(t.b.y - t.a.y) + t.a.x - t.b.x));
    assert((k *(t.c.y - t.a.y) + t.a.x - t.c.x));
    assert((k *(t.c.y - t.b.y) + t.b.x - t.c.x));
    double y01 = (x0*y1 - y0*x1) / (k *(t.b.y - t.a.y) + t.a.x - t.b.x);
    double y02 = (x0*y2 - y0*x2) / (k *(t.c.y - t.a.y) + t.a.x - t.c.x);
    double y12 = (x1*y2 - y1*x2) / (k *(t.c.y - t.b.y) + t.b.x - t.c.x);
    double x01 = k * y01;
    double x02 = k * y02;
    double x12 = k * y12;
    char int1 = (x01 >= -EPS && x01 <= f.x + EPS) && ((x01 >= min(x0, x1) - EPS) && (x01 <= max(x0, x1) + EPS));
    char int2 = (x02 >= -EPS && x02 <= f.x + EPS) && ((x02 >= min(x0, x2) - EPS) && (x02 <= max(x0, x2) + EPS));
    char int3 = (x12 >= -EPS && x12 <= f.x + EPS) && ((x12 >= min(x1, x2) - EPS) && (x12 <= max(x1, x2) + EPS));
    //cout << x0 << ' ' << y0 << "\n" << x1 << ' ' << y1 << "\n" << x2 << ' ' << y2 << "\n";
    //cout << int1 << ' ' << int2 << ' ' << int3 << "\n";

    if(int1 + int2 + int3 > 1) return 1;
    else return 0;
}

int main()
{
    freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0);
    point f;
    cin >> f.x >> f.y;
    double S = 0;
    point a(0, 0), b(10, 10), c(10, 0);
    triangle cur(a, b, c);
    double cur_S = 50;
    for(int y = 0;y<40;y++)
    {
        cur_S /= 2;
        pair<triangle, triangle> bi = divide(cur, f);
        triangle a = bi.first;
        triangle b = bi.second;
        /*cout << a.a.x << ' ' << a.a.y << "\n";
        cout << a.b.x << ' ' << a.b.y << "\n";
        cout << a.c.x << ' ' << a.c.y << "\n";
        cout << "\n";
        cout << b.a.x << ' ' << b.a.y << "\n";
        cout << b.b.x << ' ' << b.b.y << "\n";
        cout << b.c.x << ' ' << b.c.y << "\n";
        cout <<"\n";*/
        if(ok)
        {
            S += cur_S;
            break;
        }
        if(check(b, f))
        {
            S += cur_S;
            //cout << "INTERSECT! " << S << "\n";
        }
        cur = bi.first;
    }
    cout << fixed <<setprecision(6) << S << endl;
    return 0;
}
