#include <iostream>
#include <iomanip>
#include <vector>
#include <bitset>
#include <algorithm>
#include <queue>
#include <cstdio>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;
typedef int huint;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define mp make_pair
#define pb push_back
#define all(x) x.begin(),x.end()

struct v2{
	ld x, y;
	v2() {}
	v2(const ld x, const ld y): x(x), y(y) {}
	v2 operator +(const v2& r) const{
		return v2(x + r.x, y + r.y); }
	v2 operator -(const v2& r) const{
		return v2(x - r.x, y - r.y); }
	v2 operator *(const ld r) const {
		return v2(x * r, y * r); }
	v2 operator /(const ld r) const {
		return v2(x / r, y / r); }
	ld sqlen() const{
		return x * x + y * y; }
	ld len() const{
		return sqrt(x * x + y * y); }
};
ld dot(const v2& l, const v2& r) {
	return l.x * r.x + l.y * r.y;
}
ld cross(const v2& l, const v2& r) {
	return l.x * r.y - l.y * r.x;
}
const ld EPS = 1e-10;
inline int sign(ld a){
	if (a > EPS) return +1;
	if (a < -EPS) return -1;
	return 0;
}
inline bool intri(const v2& a, const v2& b, const v2& c, const v2& f){
	int s1 = sign(cross(f - a, b - a));
	int s2 = sign(cross(f - b, c - b));
	int s3 = sign(cross(f - c, a - c));
	if (s1 == 0 || s2 == 0 || s3 == 0) return false;
	return s1 == s2 && s2 == s3;
}

inline bool inter(const v2& a, const v2& b, const v2& c, const v2& d){
	v2 MIN = v2(max(min(a.x, b.x), min(c.x, d.x)), max(min(a.y, b.y), min(c.y, d.y)));
	v2 MAX = v2(min(max(a.x, b.x), max(c.x, d.x)), min(max(a.y, b.y), max(c.y, d.y)));
	if (MIN.x > MAX.x || MIN.y > MAX.y) return false;
	int s1 = sign(cross(a - b, c - b));
	int s2 = sign(cross(a - b, d - b));
	if (s1 == s2 && s1 != 0) return false;
	s1 = sign(cross(c - d, a - d));
	s2 = sign(cross(c - d, b - d));
	if (s1 == s2 && s1 != 0) return false;
	return true;
}

inline bool f(const v2& a, const v2& b, const v2& c, const v2& f){
	int cnt = 0;
	if (inter(a, b, f, v2(0, 0))) ++cnt;
	if (inter(c, b, f, v2(0, 0))) ++cnt;
	if (inter(a, c, f, v2(0, 0))) ++cnt;
	return cnt >= 1;
}


int main(){
	ios_base::sync_with_stdio(false);
	v2 A(0, 0);
	v2 B(10, 0);
	v2 C(10, 10);
	ld curS = 25;
	v2 F(8.125, 4.375);
	cin >> F.x >> F.y;
	ld ans = 0;
	for (int i = 0; i < 1000; ++i){
		v2 D = (A + C) / 2;
		if (intri(A, B, D, F)){
			if (f(B, D, C, F)) ans += curS;
			C = B;
			B = D;
		} else if (intri(C, B, D, F)){
			if (f(A, D, B, F)) ans += curS;
			A = B;
			B = D;
		} else {
			if (f(B, C, D, F) || f(A, B, D, F)) ans += curS;
			break;
		}
		curS /= 2;
		//cout << i << endl;
	}
	cout << fixed << setprecision(10) << ans << endl;
	return 0;
}