#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>
#include <queue>
#include <cstdio>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;
typedef int huint;
typedef long long ll;
#define mp make_pair
#define pb push_back
#define all(x) x.begin(),x.end()

struct v2{
	int x, y, id;
	v2() {}
	v2(const int x, const int y, const int id): x(x), y(y), id(id) {}
	v2(const int x, const int y): x(x), y(y) {}
	v2 operator +(const v2& r) const{
		return v2(x + r.x, y + r.y); }
	v2 operator -(const v2& r) const{
		return v2(x - r.x, y - r.y); }
	double sqlen() const{
		return x * x + y * y; }
	bool operator <(const v2& r) {
		return x < r.x || x == r.x && y < r.y; }
};
int dot(const v2& l, const v2& r) {
	return l.x * r.x + l.y * r.y;
}
int cross(const v2& l, const v2& r) {
	return l.x * r.y - l.y * r.x;
}

struct CMP{
	v2 O;
	CMP(const v2& O): O(O) {}
	bool operator () (const v2& l, const v2& r){
		int s = cross(l - O, r - O);
		return s > 0 || s == 0 && (l - O).sqlen() < (r - O).sqlen();
	}
};

const int N = 20001;
int ans[N];
inline void f(vector<v2>& pts){
	vector<v2> hull;
	int cur = 0;
	while (pts.size() > 0) {
		++cur;
		hull.resize(0);
		v2 base = pts[0];
		for (int i = 1; i < pts.size(); ++i)
			if (pts[i] < base)
				base = pts[i];
		sort(pts.begin(), pts.end(), CMP(base));
		for (int i = 0; i < pts.size(); ++i){
			v2 x = pts[i];
			while (hull.size() > 1 && cross(hull.back() - hull[hull.size() - 2], x - hull[hull.size() - 2]) < 0)
				hull.pop_back();
			hull.push_back(x);
		}
		for (int i = 0; i < hull.size(); ++i)
			ans[hull[i].id] = cur;
		for (int i = 0; i < pts.size(); ) {
			if (ans[pts[i].id] != 0){
				swap(pts[i], pts.back());
				pts.pop_back();
			}
			else
				++i;
		}


	}
}

int main(){
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	vector<v2> v(n);
	for (int i = 0; i < n; ++i){
		cin >> v[i].x >> v[i].y;
		v[i].id = i;
	}
	f(v);
	for (int i = 0; i < n; ++i)
		cout << ans[i] << endl;
	return 0;
}