#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const double eps = 1e-10;
const double INF = 1e18;

double sqr(double x) {
	return x * x;
}

struct pt3d {
	double x, y, z;
	pt3d(double x, double y, double z): x(x), y(y), z(z) {}
	pt3d() {}
	void read() {
		scanf("%d%d%d", &x, &y, &z);
	}
	void norm() {
		double d = sqrt(sqr(x) + sqr(y) + sqr(z));
		x /= d, y /= d, z /= d;
	}
};

struct pt {
	double x, y;
};

pt3d operator-(const pt3d& a, const pt3d& b) {
	return pt3d(a.x - b.x, a.y - b.y, a.z - b.z);
}

double det2(const int64& a, const int64& b, const int64& c, const int64& d) {
	return a * d - b * c;
}

pt3d vmul(const pt3d& b, const pt3d& c) {
	return pt3d(det2(b.y, b.z, c.y, c.z), -det2(b.x, b.z, c.x, c.z), det2(b.x, b.y, c.x, c.y));
}

int sign(const double& x) {
	return ((x > eps) ? 1 : ((x < -eps) ? -1 : 1));
}

double smul(const pt3d& b, const pt3d& c) {
	return b.x * c.x + b.y * c.y + b.z * c.z;
}

int m, h, H, x[5], y[5];
pt3d p[5];

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	scanf("%d%d%d", &m, &h, &H);
	for (int i = 0; i <= 4; ++i)
		scanf("%d%d", &x[i], &y[i]);
	p[0] = pt3d(x[0], y[0], h), p[1] = pt3d(x[1], y[1], 0), p[2] = pt3d(x[2], y[2], 0), p[3] = pt3d(x[3], y[3], 0), p[4] = pt3d(x[4], y[4], H);
	double dist = INF;
	for (int i = 1; i <= 4; ++i)
		for (int j = i + 1; j <= 4; ++j)
			for (int k = j + 1; k <= 4; ++k) {
				pt3d norm = vmul(p[k] - p[i], p[k] - p[j]);
				norm.norm();
				dist = min(dist, fabs(smul(p[0] - p[i], norm)));
			}
	printf("%s\n", (dist + h < m + eps) ? "YES" : "NO");
	return 0;
}