#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const int N = (int) 2e5 + 10;
int64 sqr(int64 x) {
	return x * x;
}
int n;

struct pt3d {
	int64 x, y, z;
	pt3d(int64 x, int64 y, int64 z): x(x), y(y), z(z) {}
	pt3d() {}
	void read() {
		scanf("%lld%lld%lld", &x, &y, &z);
	}
} p[N];

pt3d operator-(const pt3d& a, const pt3d& b) {
	return pt3d(a.x - b.x, a.y - b.y, a.z - b.z);
}

pt3d operator+(const pt3d& a, const pt3d& b) {
	return pt3d(a.x + b.x, a.y + b.y, a.z + b.z);
}

int64 det2(const int64& a, const int64& b, const int64& c, const int64& d) {
	return a * d - b * c;
}

int64 det3(const pt3d& a, const pt3d& b, const pt3d& c) {
	return a.x * det2(b.y, b.z, c.y, c.z) - a.y * det2(b.x, b.z, c.x, c.z) + a.z * det2(b.x, b.y, c.x, c.y);
}

pt3d vmul(const pt3d& b, const pt3d& c) {
	return pt3d(det2(b.y, b.z, c.y, c.z), -det2(b.x, b.z, c.x, c.z), det2(b.x, b.y, c.x, c.y));
}

pt3d operator*(const pt3d& a, double d) {
	return pt3d(a.x * d, a.y * d, a.z * d);
}

int sign(const int64& x) {
	return ((x > 0) ? 1 : ((x < 0) ? -1 : 0));
}

double smul(const pt3d& b, const pt3d& c) {
	return b.x * c.x + b.y * c.y + b.z * c.z;
}

struct face {
	int i, j, k, sign;
	face(int i, int j, int k, int l): i(i), j(j), k(k) {
		sign = ::sign(det3(p[j] - p[i], p[k] - p[i], p[l] - p[i]));
	}
	int get(int l) {
		return ::sign(det3(p[j] - p[i], p[k] - p[i], p[l] - p[i]));
	}
};

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	scanf("%d", &n);
	for (int i = 0; i < n; ++i)
		p[i].read();
	do {
		random_shuffle(p, p + 10);
	} while (det3(p[3] - p[0], p[2] - p[0], p[1] - p[0]) == 0);
	vector<face> faces;
	faces.pb(face(0, 1, 2, 3));
	faces.pb(face(0, 1, 3, 2));
	faces.pb(face(0, 2, 3, 1));
	faces.pb(face(1, 2, 3, 0));
	for (int i = 4; i < n; ++i) {
		vector< pair< pair<int, int>, int > > v;
		for (int j = sz(faces) - 1; j >= 0; --j) {
			int sgn = faces[j].get(i);
			if (sgn * faces[j].sign >= 0) continue;
			v.pb(mp(mp(faces[j].i, faces[j].j), faces[j].k));
			v.pb(mp(mp(faces[j].i, faces[j].k), faces[j].j));
			v.pb(mp(mp(faces[j].j, faces[j].k), faces[j].i));
			swap(faces[j], faces.back());
			faces.pop_back();
		}
		sort(v.begin(), v.end());
		for (int j = 0; j < sz(v); ++j) {
			if ((j > 0) && (v[j].fs == v[j - 1].fs)) continue;
			if ((j + 1 < sz(v)) && (v[j].fs == v[j + 1].fs)) continue;
			faces.pb(face(v[j].fs.fs, v[j].fs.sc, i, v[j].sc));
		}
	}
	int64 sum = 0;
	for (int i = 0; i < sz(faces); ++i)
		sum += abs(det3(p[faces[i].i] - p[0], p[faces[i].j] - p[0], p[faces[i].k] - p[0]));
	printf("%lld\n", sum);
	return 0;
}