#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip>  
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const ld eps = 1e-8;
const ld inf = 1e100; 

struct Vec {
	ld x, y; 
	Vec(ld _x = 0, ld _y = 0) : x(_x), y(_y) {}
}; 

typedef Vec Point; 

struct Line {
	ld a, b, c;
	Line(ld _a = 0, ld _b = 0, ld _c = 0) : a(_a), b(_b), c(_c) {}

	bool cross(const Line & other, Point &res) {
		ld d = a * other.b - other.a * b; 
		if (abs(d) < eps) return false;
		ld x = (-c * other.b + b * other.c) / d; 
		ld y = (-a * other.c + c * other.a) / d; 
		res = Point(x, y); 
		return true; 
	}
}; 

struct SuperLine {
	Line l; 
	Vec norm; 
	SuperLine(const Line &other, const Vec &n2) : l(other), norm(n2) {}
	SuperLine() {} 

	bool inline inHalfPlane(const Point &p ) {
		return l.a * p.x + l.b * p.y + l.c < eps; 
	}
}; 

ld vecm(const Vec &a, const Vec &b) {
	return a.x * b.y - a.y * b.x; 
}

namespace SuperLineComparator {
	bool inline ByAngle(const SuperLine &a, const SuperLine &b) {
		return atan2(a.norm.y, a.norm.x) < atan2(b.norm.y, b.norm.x);
	}
}

vector<SuperLine> st, l; 
int n; 

void input() {
	cin >> n; 
	for (int i = 0; i < n; i++) {
		ld aa, bb, cc; 
		cin >> aa >> bb >> cc; 
		Line line(aa, bb, -cc); 
		Vec norm = Point(aa, bb); 
		Point p(0, 0); 
		if (abs(bb) < eps) {
			p = Point(cc / aa, 0); 
		} else {
			p = Point(0, cc / bb); 
		}
		Point pp(p.x + norm.x, p.y + norm.y); 
		if (aa * pp.x + bb * pp.y < cc) {
			l.pb(SuperLine(line, norm)); 
		} else {
			norm.x *= -1; 
			norm.y *= -1; 
			l.pb(SuperLine(line, norm)); 
		}
	}
}

void solution() {
	Point ar[4] = { Point(-inf, -inf), Point(-inf, inf), Point(inf, -inf), Point(inf, inf) }; 
	for (int i = 0; i < 4; i++) {
		bool okk = 1; 
		for (int j = 0; j < n && okk; j++) 
		{
			if (!l[j].inHalfPlane(ar[i])) okk = 0; 
		}
		if (okk) {
			cout << -1 << "\n";
			return; 
		}
	}
	/*{
		vector< SuperLine > up, down;
		for (int i = 0; i < int(l.size()); ++i) {
			if (vecm(Vec(1., 0), l[i].norm) > 0) {
				up.push_back(l[i]);
			} else {
				down.push_back(l[i]);
			}
		}
		sort(up.begin(), up.end(), SuperLineComparator::ByAngle);
		sort(down.begin(), down.end(), SuperLineComparator::ByAngle);
		l = up;
		l.insert(l.end(), down.begin(), down.end());
	}*/
	sort(l.begin(), l.end(), SuperLineComparator::ByAngle); 
	st.resize(n); 
	st[0] = l[0]; 
	st[1] = l[1]; 
	int stSize = 2; 
	for (int i = 2; i < n; i++) {
		while (stSize >= 2) {
			Point p(0, 0); 
			st[stSize - 1].l.cross(st[stSize - 2].l, p);  
			if (!l[i].inHalfPlane(p)) stSize--; 
			else break; 
		}
		st[stSize++] = l[i]; 
	}
	reverse(st.begin(), st.begin() + stSize); 
	while (stSize >= 2) {
		Point p(0, 0); 
		st[stSize - 1].l.cross(st[stSize - 2].l, p); 
		if (!st[0].inHalfPlane(p)) --stSize; 
		else break; 
	}

	Point p; 
	st[0].l.cross(st[1].l, p); 
	for (int i = 0; i < n; i++) {
		if (!l[i].inHalfPlane(p)) 
		{
			cout << 0 << "\n"; 
			return; 
		}
	}
	vector<Point> res; 
	p = Point(0, 0); 
	for (int i = 1; i < stSize; i++) {
		st[i - 1].l.cross(st[i].l, p); 
		res.pb(p); 
	}
	st[0].l.cross(st[stSize - 1].l, p); 
	res.pb(p); 

	ld s = 0; 
	for (int i = 0; i < res.size(); i++) {
		int j = i - 1; 
		if (j < 0) j = int(res.size()) -1;
		s += vecm(res[i], res[j]); 
	}
	s *= 0.5; 
	s = abs(s); 

	/*for (int i = 0; i < res.size(); i++) {
		cout << res[i].x << " " << res[i].y << "\n"; 
	}*/
	cout.setf(ios::fixed); 
	cout.precision(20); 
	cout << s << endl; 
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
ios::sync_with_stdio(false); 


	input(); 
	solution(); 

	
	return 0;
}