#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = int(1e5) + 100;

struct point {

	double x, y;

	point() {}

	point(double x, double y) {
		this->x = x;
		this->y = y;
	}

};

struct line {

	double a, b, c;

	line() {}

	line(point &A, point &B) {
		a = A.y - B.y;
		b = B.x - A.x;
		c = -a * A.x - b * A.y;
	}

};

bool fl2;
bool used[N];
point p[N];
pair<line, int> st[N];

inline double dist(line &l, point &p) {
	return l.a * p.x + l.b * p.y + l.c;
}

inline bool bad(line &a, line &b, line &c) {
	double d = a.a * b.b - b.a * a.b;
	if (fabs(d) < eps) {
		fl2 = false;
		return false;
	}
	point cur((a.b * b.c - b.b * a.c) / d, (a.c * b.a - a.a * b.c) / d);
	assert(fabs(dist(a, cur)) < eps && fabs(dist(b, cur)) < eps);
	if (dist(c, cur) < -eps) {
		return true;
	}
	return false;
}

int main() {
#ifdef LOCAL42
#define TASK "D"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		scanf("%lf %lf", &p[i].x, &p[i].y);
	}
	reverse(p, p + n);
	int ans = -1, l = 1, r = n - 1;
	while (l <= r) {
		int mid = (l + r) / 2, sz = 0;
		fl2 = true;
		for (int i = 0; i < 2 * n && fl2; ++i) {
			line l(p[i % n], p[(i + mid) % n]);
			while (sz >= 2 && bad(st[sz - 2].fs, st[sz - 1].fs, l)) {
				--sz;
			}
			st[sz++] = mp(l, i % n);
		}
		for (int i = 0; i < n; ++i) {
			used[i] = false;
		}
		bool fl = false;
		for (int i = 0; i < sz; ++i) {
			if (used[st[i].sc]) {
				fl = true;
				break;
			}
			used[st[i].sc] = true;
		}
		if (fl && fl2) {
			ans = mid;
			l = mid + 1;
		} else {
			r = mid - 1;
		}
	}
	cout << ans << endl;
	return 0;
}
