#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

#define double ld

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = int(1e6) + 100;

struct point {

	double x, y;

	point() {}

	point(double x, double y) {
		this->x = x;
		this->y = y;
	}

};

struct line {

	double a, b, c;
	double ang;

	line() {}

	line(point &A, point &B) {
		a = A.y - B.y;
		b = B.x - A.x;
		c = -a * A.x - b * A.y;
		ang = atan2l(b, a);
	}

};

bool operator < (const line &a, const line &b) {
	if (fabsl(a.ang - b.ang) < eps) {
		return a.c > b.c;
	}
	return a.ang < b.ang;
}

bool operator == (const line &a, const line &b) {
	return fabsl(a.ang - b.ang) < eps;
}

int used[N];
pair<line, int> lines[N];
pair<line, int> st[N];
point p[N];

inline double dist(line &l, point &p) {
	return l.a * p.x + l.b * p.y + l.c;
}

inline point inter(line &a, line &b) {
	double d = a.a * b.b - b.a * a.b;
	point cur((a.b * b.c - b.b * a.c) / d, (a.c * b.a - a.a * b.c) / d);
	return cur;
}

inline bool bad(line &a, line &b, line &c) {
	point cur = inter(a, b);
	if (dist(c, cur) < eps) {
		return true;
	}
	return false;
}

inline int my_rand() {
	return (rand() << 15) | rand();
}

inline void gen() {
	freopen("D2.in", "w", stdout);
	int n = 1000;
	cout << n << endl;
	vector<double> angs;
	for (int i = 0; i < 1000; ++i) {
		double ang = my_rand() * 1.0 / (RAND_MAX * (RAND_MAX + 1) + RAND_MAX) * 2 * pi;
		angs.pb(ang);
	}
	sort(all(angs));
	for (int i = 0; i < sz(angs); ++i) {
		int x = 1e6 * cos(angs[i]);
		int y = 1e6 * sin(angs[i]);
		cout << x << " " << y << endl;
	}
	exit(0);
}

inline double calc(point &a, point &b) {
	return a.x * b.y - b.x * a.y;
}

int main() {
	//gen();
#ifdef LOCAL42
#define TASK "I"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		scanf("%Lf %Lf %Lf", &lines[i].fs.a, &lines[i].fs.b, &lines[i].fs.c);
		lines[i].fs.a *= -1;
		lines[i].fs.b *= -1;
		lines[i].fs.ang = atan2(lines[i].fs.b, lines[i].fs.a);
		lines[i].sc = i;
	}
	point box[4];
	box[0] = point(-inf, -inf);
	box[1] = point(inf, -inf);
	box[2] = point(inf, inf);
	box[3] = point(-inf, inf);
	int mem_n = n;
	for (int i = 0; i < 4; ++i) {
		lines[n] = mp(line(box[i], box[(i + 1) % 4]), n);
		++n;
	}
	sort(lines, lines + n);
	int m = unique(lines, lines + n) - lines;
	for (int i = 0; i < n; ++i) {
		used[i] = -1;
	}
	int sz = 0;
	for (int i = 0; i < 2 * m; ++i) {
		pair<line, int> cur = lines[i % m];
		if (i >= m) {
			cur.fs.ang += 2 * pi;
		}
		while (sz > 0) {
			if (cur.fs.ang - st[sz - 1].fs.ang > pi - eps) {
				used[st[--sz].sc] = -1;
				continue;
			}
			if (sz >= 2 && bad(st[sz - 2].fs, st[sz - 1].fs, cur.fs)) {
				used[st[--sz].sc] = -1;
				continue;
			}
			break;
		}
		if (used[cur.sc] != -1) {
			for (int j = used[cur.sc]; j < sz; ++j) {
				if (st[j].sc >= mem_n) {
					puts("-1");
					return 0;
				}
			}
			int cnt = 0;
			for (int j = used[cur.sc]; j < sz; ++j) {
				p[cnt++] = inter(st[j].fs, (j + 1 < sz ? st[j + 1].fs : st[used[cur.sc]].fs));
			}
			double sum = 0;
			for (int j = 0; j < cnt; ++j) {
				sum += calc(p[j], p[(j + 1) % cnt]);
			}
			sum = fabsl(sum) / 2;
			printf("%.18Lf\n", sum);
			return 0;
		}
		used[cur.sc] = sz;
		st[sz++] = cur;
	}
	puts("0");
	return 0;
}
