#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>
#include <iomanip>
#define EPS 1e-15
using namespace std;

struct Punct{double x, y;};
Punct a, b, c, d, F, AA;
double sol;


double Det(Punct A, Punct B, Punct C)
{
    return (A.x * B.y + B.x * C.y + C.x * A.y - A.y * B.x - B.y * C.x - C.y * A.x);
}

double Arie(Punct A, Punct B, Punct C)
{
    return (0.5 * fabs(Det(A, B, C)));
}

bool Interior(Punct A, Punct B, Punct C)
{
    double arie = Arie(A, B, C);
    double arie2 = Arie(A, B, F) + Arie(A, F, C) + Arie(F, B ,C);
    if(fabs(arie - arie2) < EPS)
        return true;
    return false;
}

int Intersect(Punct A, Punct B, Punct C, Punct D)
{
    double d1, d2, d3, d4;
    d1 = Det(A, B, C);
    d2 = Det(A, B, D);
    d3 = Det(C, D, A);
    d4 = Det(C, D, B);
    if(d1 * d2 < EPS && d3 * d4 < EPS)
        return 1;
    return 0;
}

int Coincid(Punct A, Punct B)
{
    if(fabs(A.x - B.x) < EPS && fabs(A.y - B.y) < EPS)
        return 1;
    return 0;
}

int main ()
{
#ifdef local
    freopen ("g.in", "r", stdin);
    freopen ("", "w", stdout);
#endif
    cin >> F.x >> F.y;
    a.x = 0.0; a.y = 0.0;
    b.x = 10.0; b.y = 0.0;
    c.x = 10.0; c.y = 10.0;
    AA = a;
    double det;
    while(1)
    {
        if(Arie(a, b, c) < EPS)
            break;
        d.x = (a.x + c.x) * 0.5;
        d.y = (a.y + c.y) * 0.5;
        int nr1, nr2;
        nr1 = nr2 = 0;
        nr1 = Intersect(AA, F, a, b) + Intersect(AA, F, a, d) + Intersect(AA, F, b, d) - Coincid(F, a) - Coincid(F, b) - Coincid(F, d) - Coincid(AA, a) - Coincid(AA, b) - Coincid(AA, d);
        nr2 = Intersect(AA, F, c, b) + Intersect(AA, F, c, d) + Intersect(AA, F, b, d) - Coincid(F, c) - Coincid(F, b) - Coincid(F, d) - Coincid(AA, c) - Coincid(AA, b) - Coincid(AA, d);
        if(nr1 == 2 || nr2 == 2)
            sol += Arie(a, b, d);
        if(Arie(a, b, F) < EPS || Arie(a, c, F) < EPS || Arie(a, d, F) < EPS || Arie(b, c, F) < EPS || Arie(b, d, F) < EPS || Arie(c, d, F) < EPS)
            break;
        det = Det(b, d, F);
        if(det > EPS || det < -EPS)
        {
            if(Interior(a, b, d))
            {
                c = b;
                b = d;
            }
            else
            {
                a = b;
                b = d;
            }
        }
        else
            break;
    }
    printf("%.8f\n", sol);
    return 0;
}
