#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

LD det(LD a, LD b,
           LD c, LD d)
{
    return a * d - b * c;
}

struct vec_t
{
    LD x, y, z;
    vec_t() {}
    vec_t(LD x, LD y, LD z) : x(x), y(y), z(z) {}
    friend vec_t operator - (const vec_t &a, const vec_t &b)
    {
        return vec_t(a.x - b.x, a.y - b.y, a.z - b.z);
    }
    friend LD cross(const vec_t &a, const vec_t &b, const vec_t &c)
    {
        return + a.x * b.y * c.z
               + b.x * c.y * a.z
               + c.x * a.y * b.z
               - c.x * b.y * a.z
               - b.x * a.y * c.z
               - a.x * c.y * b.z;
    }
    
    friend LD cross(const vec_t &a, const vec_t &b)
    {
        LD d1 = det(a.x, a.y,
                    b.x, b.y);
        LD d2 = det(a.x, a.z,
                    b.x, b.z);
        LD d3 = det(a.y, a.z,
                    b.y, b.z);
        return sqrt(d1 * d1 + d2 * d2 + d3 * d3);
    }
};

LD dist_to_plane(const vec_t &a, const vec_t &b, const vec_t &c, const vec_t &p)
{
    return fabs(cross(p - a, b - a, c - a)) / cross(b - a, c - a);
}

bool solve()
{
    int m, h, H;
    cin >> m >> h >> H;
    vector< vec_t > p(5);
    forn(i, 5)
        cin >> p[i].x >> p[i].y;

    p[0].z = h;
    p[4].z = H;

    LD d1 = dist_to_plane(p[1], p[4], p[2], p[0]);
    LD d2 = dist_to_plane(p[2], p[4], p[3], p[0]);
    LD d3 = dist_to_plane(p[1], p[4], p[3], p[0]);
    LD d4 = h;

    LD min_d = min(min(d1, d2), min(d3, d4));

    m -= h;
    return min_d - eps < m;
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    // freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    puts(solve() ? "YES" : "NO");
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif