#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

struct vec_t
{
    LD x, y;
    vec_t(LD x, LD y) : x(x), y(y) {}
    vec_t() {}
    friend vec_t operator - (const vec_t &a, const vec_t &b)
    {
        return vec_t(a.x - b.x, a.y - b.y);
    }
    friend vec_t operator + (const vec_t &a, const vec_t &b)
    {
        return vec_t(a.x + b.x, a.y + b.y);
    }
    friend LD cross(const vec_t &a, const vec_t &b)
    {
        return a.x * b.y - b.x * a.y;
    }
    friend bool operator < (const vec_t &a, const vec_t &b)
    {
        return mp(a.x, a.y) < mp(b.x, b.y);
    }
    friend vec_t operator / (const vec_t &a, LD val)
    {
        return vec_t(a.x / val, a.y / val);
    }
    LD len() const 
    {
        return sqrt(x * x + y * y);
    }
    friend LD dist(const vec_t &a, const vec_t &b)
    {
        return (a - b).len();
    }
};

//vec_t get_intersection(const vec_t &a, const vec_t &b, const vec_t &c, const vec_t &d)
//{
//}

bool is_intersect(const vec_t &a, const vec_t &b, const vec_t &c, const vec_t &d)
{
    return cross(c - a, b - a) * cross(d - a, b - a) < +eps &&
           cross(a - d, c - d) * cross(b - d, c - d) < -eps;
}

bool on_segm(const vec_t &a, const vec_t &b, const vec_t &p)
{
    return fabs(cross(p - a, b - a)) < eps &&
           dist(a, p) < dist(a, b) + eps &&
           dist(b, p) < dist(a, b) + eps;
}

bool check_intersect(const vec_t &a, const vec_t &b, const vec_t &c, const vec_t &u, const vec_t &v)
{
    int cnt = 0;
    cnt += is_intersect(a, b, u, v);
    cnt += is_intersect(b, c, u, v);
    cnt += is_intersect(c, a, u, v);

    cnt += on_segm(u, v, a);
    cnt += on_segm(u, v, b);
    cnt += on_segm(u, v, c);

    return cnt == 2;
}

bool check_inside(const vec_t &a, const vec_t &b, const vec_t &c, const vec_t &p)
{
    return  cross(b - a, p - a) > -eps &&
            cross(c - b, p - b) > -eps &&
            cross(a - c, p - c) > -eps;
}

LD res = 0;

void go(const vec_t &a, const vec_t &b, const vec_t &c, const vec_t &f)
{
    LD area = fabs(cross(b - a, c - a)) / 2;
    if (area < eps)
        return;
    
    vec_t m = (a + c) / 2;

    if (check_intersect(a, b, m, vec_t(0, 0), f))
        res += area / 2;

    if (check_intersect(b, c, m, vec_t(0, 0), f))
        res += area / 2;

    if (fabs(cross(f - b, m - b)) < eps)
        return;

    if (check_inside(a, b, m, f))
        go(a, m, b, f);
    
    if (check_inside(c, m, b, f))
        go(c, m, b, f);
}

void solve()
{
    vec_t a(0, 0), b(10, 0), c(10, 10);
    vec_t f; cin >> f.x >> f.y;
    cout.setf(ios::fixed);
    cout.precision(9);

    go(a, b, c, f);

    cout << res << endl;
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    // freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif