#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

struct pt
{
    LL x, y;
    int id;
    pt() {}
    pt(LL x, LL y, int id) : x(x), y(y), id(id) {}

    friend bool operator< (const pt &a, const pt &b)
    {
        return mp(a.x, mp(a.y, a.id)) < mp(b.x, mp(b.y, b.id));
    }

    friend pt operator-(const pt &a, const pt &b)
    {
        return pt(a.x - b.x, a.y - b.y, -1);
    }
};

LL vect(const pt &a, const pt &b, const pt &c)
{
    pt ab = b - a;
    pt ac = c - a;
    return ab.x * ac.y - ab.y * ac.x;
}

int n;
vector <pt> a;

vector <int> used;
int cnt = 0;

void convex_hull(int cl)
{
    vector <pt> h;
    for (int i = 0; i < n; i++)
    {
        if (used[a[i].id] != -1)
            continue;
        while (h.size() > 1 && vect(h[h.size() - 2], h[h.size() - 1], a[i]) > 0 )
            h.pop_back();
        h.pb(a[i]);
    }
    int sz = h.size();
    for (int i = n - 2; i >= 0; i--)
    {
        if (used[a[i].id] != -1)
            continue;
        while (h.size() > sz && vect(h[h.size() - 2], h[h.size() - 1], a[i]) > 0 )
            h.pop_back();
        h.pb(a[i]);
    }
    h.pop_back();
    for (int i = 0; i < h.size(); i++)
        used[h[i].id] = cl;
    cnt += h.size();
}

void solve()
{
    scanf("%d", &n);
    a.resize(n);
    for (int i = 0; i < n; i++)
    {
        int x, y;
        scanf("%d %d", &x, &y);
        a[i] = pt(x, y, i);
    }
    sort(a.begin(), a.end());
    used.resize(n, -1);
    int cl = 1;
    while (cnt < n)
        convex_hull(cl++);

    for (int i = 0; i < n; i++)
        printf("%d\n", used[i]);
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif